<?php
/*
Plugin Name: Headway Leaf: Gallery+  Now four leafs in one!
Plugin URI: http://headwaythemes.com
Description: A plugin that provides four leafs that provide ways to show your images in galleries. As well as its own gallery system, it will also read existing WordPress, Headway and NextGen galleries.
Author: Chris Howard
Version: 1.1.2
Author URI: http://leafs.341design.com.au
*/
define('GP_VERSION','1.1.2');


define('GP_LEAF_URL', substr(WP_PLUGIN_URL.'/'.str_replace(basename(__FILE__),'', plugin_basename(__FILE__)), 0, -1));
define('GP_LEAF_PATH', substr(WP_PLUGIN_DIR.'/'.str_replace(basename(__FILE__),'', plugin_basename(__FILE__)), 0, -1));

define('GP_CACHE_URL', WP_CONTENT_URL.'/pluscache/gplus');
define('GP_CACHE_PATH', WP_CONTENT_DIR.'/pluscache/gplus');

define('GP_CACHE_URL_PREFIX', GP_CACHE_URL.'/gplus-');
define('GP_CACHE_PATH_PREFIX', GP_CACHE_PATH.'/gplus-');

define('GP_STYLES_PATH',GP_LEAF_PATH.'/styles');
define('GP_STYLES_URL',GP_LEAF_URL.'/styles');
define('GP_GALLERIES_PATH',GP_LEAF_PATH.'/galleries');
define('GP_MEDIA_URL',GP_LEAF_URL.'/media');
define('GP_MEDIA_PATH',GP_LEAF_PATH.'/media');
define('GP_JS_URL',GP_LEAF_URL.'/js');


define('GPUSERGUIDE', 'http://leafs.341design.com.au/gallery-user-guide/');
define('GP_COLOUR_PICKER','http://www.colorpicker.com/');
define('CHDEBUG', 'true');


// Load top level functions
require GP_LEAF_PATH.'/gp_functions.php';
require GP_LEAF_PATH.'/gp_image_resizer.php';
require GP_LEAF_PATH.'/gp_admin.php';
require GP_LEAF_PATH.'/gp_leaf_layout.php';
require GP_LEAF_PATH.'/gp_leaf_options_generic.php';

// Load styles functions
require GP_STYLES_PATH.'/gp_layout_sliderkit.php';
require GP_STYLES_PATH.'/gp_layout_grid.php';
require GP_STYLES_PATH.'/gp_layout_carousel.php';
require GP_STYLES_PATH.'/gp_layout_accordion.php';
/* include GP_STYLES_PATH.'/gp_layout_galleriffic.php'; */


// Load gallery functions
require GP_GALLERIES_PATH.'/gp_gallery_functions.php';
require GP_GALLERIES_PATH.'/hw_gallery_functions.php';
require GP_GALLERIES_PATH.'/ng_gallery_functions.php';
require GP_GALLERIES_PATH.'/gp_sample_gallery_functions.php';
require GP_GALLERIES_PATH.'/wp_gallery_functions.php';

// Initialize
add_action('init', 'gp_register_leaf');
add_action('wp_head', 'gp_leaf_head', 2);
add_action('headway_ve_head', 'gp_load_ve_css', 2);
register_deactivation_hook( __FILE__, 'gp_deactivate' );

function gp_register_leaf(){	
	$options = array(
			'id' => 'gallery-plus',
			'name' => 'Gallery+ Slider',
			'options_callback' => 'gp_leaf_options_slider',
			'options_width' => 750,
			'icon' => GP_MEDIA_URL.'/icons/icon.png',
			'js_callback' => 'gp_scripts_gallery_slider',
			'content_callback' => 'gp_layout'
		);

	if(class_exists('HeadwayLeaf'))	$gp_leaf = new HeadwayLeaf($options);

	$options = array(
			'id' => 'gallery-plus-grid',
			'name' => 'Gallery+ Thumbs Grid',
			'options_callback' => 'gp_leaf_options_grid',
			'options_width' => 750,
			'icon' => GP_MEDIA_URL.'/icons/icon_grid.png',
			'js_callback' => 'gp_scripts_gallery_grid',
			'content_callback' => 'gp_layout'
		);

	if(class_exists('HeadwayLeaf'))	$gp_leaf = new HeadwayLeaf($options);

	$options = array(
			'id' => 'gallery-plus-carousel',
			'name' => 'Gallery+ Carousel',
			'options_callback' => 'gp_leaf_options_carousel',
			'options_width' => 750,
			'icon' => GP_MEDIA_URL.'/icons/icon_carousel.png',
			'js_callback' => 'gp_scripts_gallery_carousel',
			'content_callback' => 'gp_layout'
		);

	if(class_exists('HeadwayLeaf'))	$gp_leaf = new HeadwayLeaf($options);


	$options = array(
			'id' => 'gallery-plus-accordion',
			'name' => 'Gallery+ Accordion',
			'options_callback' => 'gp_leaf_options_accordion',
			'options_width' => 750,
			'icon' => GP_MEDIA_URL.'/icons/icon_accordion2.png',
			'js_callback' => 'gp_scripts_gallery_accordion',
			'content_callback' => 'gp_layout'
		);

	if(class_exists('HeadwayLeaf'))	$gp_leaf = new HeadwayLeaf($options);

/*
	$options = array(
			'id' => 'gallery-plus-galleriffic',
			'name' => 'Gallery+ Galleriffic',
			'options_callback' => 'gp_leaf_options_galleriffic',
			'options_width' => 750,
			'icon' => GP_MEDIA_URL.'/icons/icon_accordion.png',
			'js_callback' => 'gp_scripts_gallery_galleriffic',
			'content_callback' => 'gp_layout'
		);

	if(class_exists('HeadwayLeaf'))	$gp_leaf = new HeadwayLeaf($options);
*/

	if (!is_dir(GP_CACHE_PATH)) {
		@mkdir(WP_CONTENT_DIR.'/pluscache');
		mkdir(WP_CONTENT_DIR.'/pluscache/gplus');
	}
}

function gp_deactivate () {
	// empty headway cache
	headway_clear_cache();
	// empty gp cache
	GPFunctions::clear_image_cache();
}


function gp_leaf_head(){
	if (is_admin()) {
		GPFunctions::check_version();
	}

	//Check if leaf is active on page.  If it is, use the CSS.
	if(!function_exists('headway_get_page_leafs')) return false;
	$leafs = headway_get_page_leafs(headway_current_page());

		
	if(count($leafs) > 0){			
//		wp_enqueue_style('headway-gallery-plus-css', GP_LEAF_URL.'/media/css/gallery_plus.css');

		$gp_embedded_css = '';
		foreach($leafs as $leaf){			
			wp_enqueue_style('headway-gallery-plus-css', GP_LEAF_URL.'/css/gallery_plus.css');
			GPFunctions::initialize_gallery_plugins($leaf);
			if($leaf['type'] == 'gallery-plus'
			  || $leaf['type'] == 'gallery-plus-accordion'
			  || $leaf['type'] == 'gallery-plus-carousel'
			  || $leaf['type'] == 'gallery-plus-grid')	{
				$leaf['options'] = maybe_unserialize($leaf['options']);
				if ($leaf['options']['gp-use-embedded']) {
					$gp_embedded_css .= "body.custom div#leaf-".$leaf['id']." {display:none;}\n\tbody.custom.visual-editor-open div#leaf-".$leaf['id']." {display:block;}\n\t";
				}
				if ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right') {
					$gp_embedded_css .= "body.custom div#leaf-".$leaf['id']." .photosgallery-vertical .sliderkit-nav-clip ul li.sliderkit-selected a {border-color:".(($leaf['options']['gp-navbordercolour']=='')?'#fff':$leaf['options']['gp-navbordercolour'])."}\n\t";
				} else {
					$gp_embedded_css .= "body.custom div#leaf-".$leaf['id']." .photosgallery-horizontal .sliderkit-nav-clip ul li.sliderkit-selected a {border-color:".(($leaf['options']['gp-navbordercolour']=='')?'#fff':$leaf['options']['gp-navbordercolour'])."}\n\t";
				}
			}
		}
		
		if ($gp_embedded_css != '') {
			echo "\n<!-- GALLERY+ EMBEDDED CSS - ONE DAY REPLACE WITH JS -->\n<style TYPE='text/css'>\n\t".$gp_embedded_css ."\n</style>";
		}
		

	}
}
function gp_load_ve_css(){
	if(headway_visual_editor_open()) {
		if(version_compare(HEADWAYVERSION, '2.0.9', '>=')){
			echo '<link rel="stylesheet" href="'.GP_LEAF_URL.'/css/gp_visual_editor.css" type="text/css" />'."\n";
		} else {
			wp_enqueue_style('headway-gallery-plus-visual-editor-css', GP_LEAF_URL.'/css/gp_visual_editor.css');
		}
	}
}


/*

Create the G+ Albums using custom post types
*/
add_action('init', 'gp_create_albums_post_type');
function gp_create_albums_post_type() 
{
  $labels = array(
    'name' => _x('G+ Galleries', 'post type general name'),
    'singular_name' => _x('Gallery', 'post type singular name'),
    'add_new' => _x('Add New Gallery', 'gallery'),
    'add_new_item' => __('Add New Gallery'),
    'edit_item' => __('Edit Gallery'),
    'new_item' => __('New Gallery'),
    'view_item' => __('View Gallery'),
    'search_items' => __('Search Gallerys'),
    'not_found' =>  __('No gallerys found'),
    'not_found_in_trash' => __('No gallerys found in Trash'), 
    'parent_item_colon' => ''

  );
  $args = array(
    'labels' => $labels,
    'public' => true,
    'publicly_queryable' => true,
    'show_ui' => true, 
    'show_in_menu' => true, 
    'query_var' => true,
    'rewrite' => true,
    'capability_type' => 'post',
    'has_archive' => true, 
    'hierarchical' => false,
    'menu_position' => 20,
    'supports' => array('title','editor')
  ); 


  register_post_type('gp_gallery',$args);

  	// Convert old albums to gp_gallery
  	add_option('gallery-plus-upgrade',1);
	if (get_option( 'gallery-plus-upgrade')) {
	  gp_convert_album_to_gallery($labels);
	  update_option('gallery-plus-upgrade',0);
	}
	
}

function gp_hide_leafs($leaf){


	echo "<style TYPE='text/css'> \n
 		body.custom div#leaf-".$leaf['id']." {display:none;}\n
		body.custom.visual-editor-open div#leaf-".$leaf['id']." {display:block;}\n
	</style>";
}

function gp_convert_album_to_gallery($labels) {
	global $wpdb, $wp_taxonomies, $wp_rewrite;
	$q = 'numberposts=-1&post_status=any&post_type=album';
  $args_album = array(
    'labels' => $labels,
    'public' => true,
    'show_ui' => false, 
    'show_in_menu' => false, 
    'query_var' => true,
    'rewrite' => true,
    'capability_type' => 'post',
    'has_archive' => true, 
    'hierarchical' => false,
    'menu_position' => 20,
    'supports' => array('title','editor')
  ); 

  register_post_type('album',$args_album);

	$items = get_posts($q);
	foreach ($items as $item) {
		
		$new_guid = str_replace('=album','=gp_gallery',$item->guid);
	
		// Update the post into the database
		$wpdb->update( $wpdb->posts, array( 'post_type' => 'gp_gallery', 'guid' => $new_guid), array( 'ID' => $item->ID, 'post_type' => 'album'), array( '%s', '%s' ), array( '%d', '%s' ) );

//		$wpdb->print_error(); 
	}
	$wp_rewrite->flush_rules();

// We don't need to deregister because the next time the admin loads, this won't be active
}



	/*	
		Shortcode the leaf
		seriously!
	*/
	
	function gp_shortcode( $atts, $content=null, $code="" ) {
	   // $atts    ::= array of attributes
	   // $content ::= text within enclosing form of shortcode element
	   // $code    ::= the shortcode found, when == callback name
	   // examples: [my-shortcode]
	   //           [my-shortcode/]
	   //           [my-shortcode foo='bar']
	   //           [my-shortcode foo='bar'/]
	   //           [my-shortcode]content[/my-shortcode]
	   //           [my-shortcode foo='bar']content[/my-shortcode]
		return '<div class="shortcodedgpleaf" style="position:relative;">'.gp_layout($atts[0]).'</div>';
	}
	
	add_shortcode( 'showgalleryplus', 'gp_shortcode' );

