<?php
/*
Functions to access the standard Headway Gallery
*/

/*
Functions
gp_get_album_name($leaf)
gp_get_wp_albums()
gp_get_gp_gallery($album,$leaf)
*/


/* Get the source to an array 
List in HTML
shove into gallery style

start with G+ gallery and Gallery plugin.
*/

function gp_get_hw_galleries() {
	// This function is used just to get the GALLEY names (not images!)
	$results = array();

	// get all hw's galleries
	$galleries = headway_get_taxonomy(array('type' => 'gallery'));
	$inc = 0;
	if ($galleries) {
		foreach ( $galleries as $gallery ) {
			// need to extract the info out of each - probably that unserialize command
			$gallery = array_map('maybe_unserialize', $gallery);
			$results[$inc++] = array('post_id' =>$gallery['id'],'title'=>$gallery['content']['name'],'source'=>'Headway PhotoGallery: ');	
		}
	}

	return $results;
}

/* -----------------------------------------------------------------------------------

Function to get the image data for selected Headway Gallery

----------------------------------------------------------------------------------- */

function gp_get_hw_gallery($album,$leaf) {
	$results = array();

	$photos = headway_get_taxonomy(array('type' => 'gallery-image', 'parent_id' => $album));
	$inc = 0;
	if(count($photos) > 0){
		foreach($photos as $photo){
			$photo = array_map('maybe_unserialize', $photo);

			$height = $leaf['options']['gp-image-height'];			
			$width = $leaf['options']['gp-image-width'];
//			$image_size = max($leaf['options']['gp-image-height'],$leaf['options']['gp-image-width']);
			$image_src = get_bloginfo('wpurl').'/wp-content/uploads/headway/gallery/'.$photo['content']['filename'];

			$results[$inc] = array('post_id' =>$photo['id'],
				'title'=>stripslashes($photo['content']['title']),
				'caption'=>stripslashes($photo['content']['caption']),
				'thumb_url'=>$image_src,
				'image_url'=>$image_src,
				'link_url'=>'');
			$inc++;


		}
	}

return $results;

}



