<?php

/* All the WP admin backend functions */
function gp_options_page() {
/*
	add_submenu_page(
		'edit.php?post_type=gp_gallery',
		'Gallery+ Templates',
		'Templates',
		'level_5',
		'gallery-plus-templates',
		'gp_admin_templates_page'
	);

	add_submenu_page(
		'edit.php?post_type=gp_gallery',
		'Add/Edit Gallery+ Templates',
		'Add New Template',
		'level_5',
		'gallery-plus-add-template',
		'gp_admin_add_template_page'
	);

	add_submenu_page(
		'edit.php?post_type=gp_gallery',
		'Gallery+ Messages',
		'Messages',
		'level_5',
		'gallery-plus-messages',
		'gp_admin_messages_page'
	);
*/
	add_submenu_page(
		'edit.php?post_type=gp_gallery',
		'Refresh Gallery+ Image Cache',
		'Refresh Image Cache',
		'manage_options',
		'gallery-plus-options',
		'gp_admin_options_page'
	);

}
add_action('admin_menu','gp_options_page');


function gp_admin_options_page() {
	global $title;
	?>
	<div class="wrap">
		
		<!-- Display Plugin Icon, Header, and Description -->
		<div class="icon32" id="icon-options-general"><br></div>
		<h2><?php echo $title ?></h2>
		<p>If you update or change images in any galleries - whether Gallery+, Headway, WordPress or NextGen - it is a good idea to refresh the Gallery+ image cache to ensure your site visitors are seeing the latest images.</p> <p>Please note: Refreshing the cache causes no problems other than the next person who visits your site may have to wait a little longer as the cache images get recreated. <strong>No images in any gallery will be affected</strong>. </p><p>Click the button to refresh the Gallery+ image cache.</p>
		<form action="edit.php?post_type=gp_gallery&page=gallery-plus-options" method="post">
			<input class="button-primary" type="submit" name="emptycache" value="Refresh Gallery+ Image Cache">
		</form>


	</div>
	<?php	
	if(isset($_POST['emptycache'])) {
		GPFunctions::clear_image_cache();
		echo '<div id="message" class="updated"><p>Gallery+ Image Cache cleared. It will be recreated next time someone vists your site.</p></div>';
	}
}

function gp_admin_messages_page() {
	global $title;
	?>
	<div class="wrap">
		
		<!-- Display Plugin Icon, Header, and Description -->
		<div class="icon32" id="icon-options-general"><br></div>
		<h2><?php echo $title ?></h2>
		<p>This page is not used yet</p>
		<p>This page allows you to configure defaults for each of the standard messages used in Gallery+ that are displayed to the end user</p>





		<!-- Beginning of the Plugin Options Form -->
		<form method="post" action="options.php">
			<?php settings_fields('gp_plugin_options'); ?>
			<?php $options = get_option('gp_options'); ?>

			<!-- Table Structure Containing Form Controls -->
			<!-- Each Plugin Option Defined on a New Table Row -->
			<table class="form-table">

Insufficient images in this post/page to create a gallery<br/>
Insufficient images in selected gallery. Please add some or select another gallery<br/>
YOUR GALLERY, BASED ON GALLERY+ LEAF NUMBER {NN}, WILL APPEAR HERE<br/>
Cannot find or access the specified image. Please check you have set a featured image, or post has an imge. Otherwise check the file permissions on your images folders<br/>
No image in selected gallery. Please add some or select another gallery<br/>

			</table>
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>

	</div>
	<?php	

}

function gp_admin_templates_page() {
	global $title;
	?>
	<div class="wrap">
		
		<!-- Display Plugin Icon, Header, and Description -->
		<div class="icon32" id="icon-options-general"><br></div>
		<h2><?php echo $title ?></h2>
		<p>No templates defined yet for Gallery+</p>
Display an Add New button up here.
		<!-- Beginning of the Plugin Options Form -->
		<form method="post" action="options.php">
			<?php settings_fields('gp_plugin_options'); ?>
			<?php $options = get_option('gp_options'); ?>

			<!-- Table Structure Containing Form Controls -->
			<!-- Each Plugin Option Defined on a New Table Row -->
       <table width="100%" class="widefat">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Style</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Style</th>
                    <th>Action</th>
                </tr>
            </tfoot>

			</table>
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>

	</div>
	<?php	
}

function gp_admin_add_template_page() {
	global $title;
	?>
	<div class="wrap">
		
		<!-- Display Plugin Icon, Header, and Description -->
		<div class="icon32" id="icon-options-general"><br></div>
		<h2><?php echo $title ?></h2>
		<p>This page is not used yet</p>
		<p>This page allows you to add settings for a new Gallery+ template. It will need to first find out what style to use. Templates can be used in shortcodes. They can also be used when Headway is not the current theme in use.</p>





		<!-- Beginning of the Plugin Options Form -->
		<form method="post" action="options.php">
			<?php settings_fields('gp_plugin_options'); ?>
			<?php $options = get_option('gp_options'); ?>

			<!-- Table Structure Containing Form Controls -->
			<!-- Each Plugin Option Defined on a New Table Row -->
			<table class="form-table">


			</table>
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>

	</div>
	<?php	

}

