<?php
/*
Build the leaf

*/

function gp_layout(){

	$arg = func_get_arg(0);
	
	// If $leaf is an array, all is good. Else, if it is an integer, then we have to go and populate it as an array from the database... just gotta find the code Clay uses for that!
	if (is_numeric($arg)) {
		$leaf = headway_get_leaf($arg);	
	} else {
		$leaf = $arg;
	}

	$return_html = '';
	$gp_panelbgcolour = 'background-color:'.(($leaf['options']['gp-panelbgcolour']=='') ? 'transparent' : $leaf['options']['gp-panelbgcolour']).';';
	$gp_panelbordercolour = 'border:'.(($leaf['options']['gp-panelbordercolour']=='') ? 'none' :$leaf['options']['gp-panelbordercolour']).' solid 1px;';

	// Calculate shadows styling
	if (!$leaf['options']['gp-gallery-shadow-inset']) {
		$gp_shadow_style = '-moz-box-shadow: XXpx YYpx DDpx #999;-webkit-box-shadow: XXpx YYpx DDpx #999;box-shadow: XXpx YYpx DDpx #999;';
		$gp_xx1 = 'XX';
		$gp_xx2 = '-XX';
		$gp_yy1 = 'YY';
		$gp_yy2 = '-YY';
		
	} else {
		$gp_shadow_style = '-moz-box-shadow: inset -XXpx -YYpx DDpx #999;-webkit-box-shadow: inset -XXpx -YYpx DDpx #999;box-shadow: inset -XXpx -YYpx DDpx #999;';
		$gp_xx1 = '-XX';
		$gp_xx2 = 'XX';
		$gp_yy1 = '-YY';
		$gp_yy2 = 'YY';
	}

	switch ($leaf['options']['gp-gallery-shadow']) {
		case 'topleft':
			$gp_shadow_style = str_replace($gp_xx1,$gp_xx2,$gp_shadow_style);
			$gp_shadow_style = str_replace($gp_yy1,$gp_yy2,$gp_shadow_style);
			break;
		case 'topright':
			$gp_shadow_style = str_replace($gp_yy1,$gp_yy2,$gp_shadow_style);
			break;
		case 'bottomleft':
			$gp_shadow_style = str_replace($gp_xx1,$gp_xx2,$gp_shadow_style);
			break;
		case 'bottomright':
			break;
		case 'centered':
			$gp_shadow_style = str_replace($gp_xx1,'0',$gp_shadow_style);
			$gp_shadow_style = str_replace($gp_yy1,'0',$gp_shadow_style);
			break;
		case 'none':
			$gp_shadow_style = '';
		break;
	
	}
	$gp_shadow_style = str_replace('XX',$leaf['options']['gp-gallery-shadow-depth'],$gp_shadow_style);
	$gp_shadow_style = str_replace('YY',$leaf['options']['gp-gallery-shadow-depth'],$gp_shadow_style);
	$gp_shadow_style = str_replace('DD',$leaf['options']['gp-gallery-shadow-spread'],$gp_shadow_style);
	$gp_shadow_style = str_replace('#999',$leaf['options']['gp-gallery-shadow-colour'],$gp_shadow_style);
	
	$gp_gallery_rotate = str_replace('DD',$leaf['options']['gp-gallery-rotate'],'-ms-transform:rotate(DDdeg);-moz-transform:rotate(DDdeg);-webkit-transform:rotate(DDdeg);-o-transform:rotate(DDdeg);transform:rotate(DDdeg);');

	// Ok, we're going to build the gallery before the container incase we need to modify the container. We can do this coz we'rre concatentating all the html to a string, rather tthan live echoing	
	if ($leaf['options']['gp-album']) {
		switch ($leaf['type']){
			case 'gallery-plus':
				$gp_our_gallery_code = gp_build_sk_gallery($leaf);
				$gallery_type = " slider-gallery";
				$gp_add_nav_width = ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right') ? ($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding']) : 0; 
				$gp_add_nav_height = ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right' || $leaf['options']['gp-nav-pos'] == 'none' ) ? 0 :($leaf['options']['gp-thumb-height']+$leaf['options']['gp-panel-padding']); // Thumb width + padding
				$gp_panel_width = ($leaf['options']['gp-image-width']+$gp_add_nav_width).'px';
				$gp_panel_height = ($leaf['options']['gp-image-height']+$gp_add_nav_height+($leaf['options']['gp-textlocation']=='above' || $leaf['options']['gp-textlocation']=='below'?75:0)).'px';
				break;
			case 'gallery-plus-grid':
				$gp_our_gallery_code = gp_build_grid_gallery($leaf);
				$gallery_type = " grid-gallery";
				$gp_panel_width = (!$leaf['options']['gp-grid-width']) ? '100%' : ($leaf['options']['gp-grid-width']).'px';
				$gp_panel_height = (!$leaf['options']['gp-grid-height']) ? '100%' : ($leaf['options']['gp-grid-height']).'px';
				break;
			case 'gallery-plus-carousel':
				$gp_our_gallery_code = gp_build_carousel_gallery($leaf);
				$gallery_type = " carousel-gallery";
				$gp_panel_width = (!$leaf['options']['gp-frame-width']) ? '100%' : ($leaf['options']['gp-frame-width']).'px';
				$gp_panel_height = (!$leaf['options']['gp-frame-height']) ? '100%' : ($leaf['options']['gp-frame-height']).'px';
				break;
			case 'gallery-plus-accordion':
				$gp_our_gallery_code = gp_build_accordion_gallery($leaf);
				$gallery_type = " accordion-gallery";
				$gp_panel_width = (!$leaf['options']['gp-frame-width']) ? '100%' : ($leaf['options']['gp-frame-width']).'px';
				// Because some of the accordion displays overflow the panel, we need to hide the panel borders etc and make some allowance
				$gp_panel_height = (!$leaf['options']['gp-frame-height']) ? '100%' : ($leaf['options']['gp-frame-height']+20).'px';
				$leaf['options']['gp-panel-padding'] = 0;
				$gp_shadow_style ="";
				$gp_panelbordercolour = "";
				$gp_panelbgcolour = "";
				break;
/*
			case 'gallery-plus-galleriffic':
				$gp_our_gallery_code = gp_build_galleriffic_gallery($leaf);
				$gallery_type = " galleriffic-gallery";
				$gp_add_nav_width = ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right') ? ($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding']) : 0; 
				$gp_add_nav_height = ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right' || $leaf['options']['gp-nav-pos'] == 'none' ) ? 0 :($leaf['options']['gp-thumb-height']+$leaf['options']['gp-panel-padding']); // Thumb width + padding
				$gp_panel_width = ($leaf['options']['gp-image-width']+$gp_add_nav_width).'px';
				$gp_panel_height = ($leaf['options']['gp-image-height']+$gp_add_nav_height+($leaf['options']['gp-textlocation']=='above' || $leaf['options']['gp-textlocation']=='below'?75:0)).'px';
				break;
*/
		}
	} else {
		$gp_our_gallery_code =  '<h2>You have not selected a gallery yet!</h2>';
	}

	$gp_no_gallery_css = '';
	if ($gp_our_gallery_code == 'no_content_gallery') {
		$gp_our_gallery_code = '<div id="sliderkit-gallery-'.$leaf['id'].'" class="gp_no_gallery">Insufficient images in this post/page to create a gallery</div>';
		$gp_no_gallery_css = 'gp_hide_gallery';
	} elseif ($gp_our_gallery_code == 'insufficient_images') {
		$gp_our_gallery_code = '<div id="sliderkit-gallery-'.$leaf['id'].'" class="gp_no_images">Insufficient images in selected gallery. Please add some or select another gallery</div>';
		$gp_no_gallery_css = 'gp_insufficient_images';
	}



	/// this needs to be fixed for correct height and width
/* 	$return_html .= '<div id="gallery-plus-'.$leaf['id'].'" class="gallery-plus-container" style="'.$gp_panelbgcolour.$gp_panelbordercolour.';width:'.$gp_panel_width.'px; height:'.$gp_panel_height.'px;padding:'.$leaf['options']['gp-panel-padding'].'px;'.$gp_shadow_style.$gp_gallery_rotate.'">'; */

	$return_html .= '<div id="gallery-plus-'.$leaf['id'].'" class="gallery-plus-container '.$gp_no_gallery_css.$gallery_type.'" style="'.$gp_panelbgcolour.$gp_panelbordercolour.';width:'.$gp_panel_width.'; height:'.$gp_panel_height.';padding:'.$leaf['options']['gp-panel-padding'].'px;'.$gp_shadow_style.$gp_gallery_rotate.'">';


	// It all happens here!
	// Call appropriate function to display the chosen gallery


/* 	$return_html .= ($leaf['options']['gp-album']) ? gp_build_gallery($leaf) : '<h2>You have not selected a gallery yet!</h2>'; */

	$return_html .= $gp_our_gallery_code;
	$return_html .= '</div><!-- end div gallery-plus-'.$leaf['id'].' -->';
	
	// Okay let's output the html or send it back to the shortcode!
	if (is_array($arg)) {
		if ($leaf['options']['gp-use-embedded'] != 'on' || headway_visual_editor_open()) {
			echo $return_html;
		}
	} else {
	
		if ($leaf['options']['gp-use-embedded'] == 'on' && headway_visual_editor_open()) {
			return '<div style="padding:10px;background:#ddd;color:#000;height:'.($leaf['options']['gp-image-height']).'px;width:'.($leaf['options']['gp-image-width']).'px;">YOUR GALLERY, BASED ON GALLERY+ LEAF NUMBER '.$leaf['id'].', WILL APPEAR HERE</div>';
		}
		if ($leaf['options']['gp-use-embedded'] == 'on' && !headway_visual_editor_open()) {
			return $return_html;
		}
	}
}

