<?php
	
/*
		$leaf['options']['gp-navfx'] = 'sliding';
		$leaf['options']['gp-navbgcolour'] = '#000';
		$leaf['options']['gp-nav-style'] = 'glossy';
		$leaf['options']['gp-navbordercolour'] = "#fff";
		$leaf['options']['gp-no_rowscols'] = 1;
		$leaf['options']['gp-source'] = '';
		$leaf['options']['gp-style'] = 'sliderkit';
*/
/* 	==============================================================================================================================
	 GENERIC OPTIONS
	============================================================================================================================== */
function gp_options_frame($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-panelbgcolour'] = '#ffffff';
		$leaf['options']['gp-panelbordercolour'] = '#cccccc';	
		$leaf['options']['gp-panel-padding'] = '10';
		$leaf['options']['gp-use-embedded'] = false;
		switch ($leaf['type']) {
			case 'gallery-plus':
				$leaf['options']['gp-frame-height'] = '400';
				$leaf['options']['gp-frame-width'] = '600';
				break;
	
			 case 'gallery-plus-grid':
				$leaf['options']['gp-frame-height'] = '600';
				$leaf['options']['gp-frame-width'] = '800';
				break;
	
			 case 'gallery-plus-accordion':
				$leaf['options']['gp-frame-height'] = '300';
				$leaf['options']['gp-frame-width'] = '800';
				break;
	
			 case 'gallery-plus-stack':
				$leaf['options']['gp-frame-height'] = '400';
				$leaf['options']['gp-frame-width'] = '400';
				break;
	
			 case 'gallery-plus-carousel':
				$leaf['options']['gp-frame-height'] = '400';
				$leaf['options']['gp-frame-width'] = '800';
				break;
		}
	}

	// ------------------------------------------------
	// FRAME tab                      -----------------
	// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('frame', $leaf['id']);

		
		if ($leaf['type'] != 'gallery-plus-accordion') {
				/* Panel Background colour */
				$title = 'Frame background colour';
				$tooltip = 'Set the frame background colour in HTML - eg. #000 = black.<br/>For help choosing HTML colour codes, click the above link to the Colour Code Generator.';
				$default = 'Default: #fff';
				HeadwayLeafsHelper::create_text_input(array('name' => 'gp-panelbgcolour', 'value' => $leaf['options']['gp-panelbgcolour'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		
				/* Panel border colour */
				$title = 'Frame border colour';
				$tooltip = 'Set the frame border colour in HTML - eg. #000 = black.<br/>For help choosing HTML colour codes, click the above link to the Colour Code Generator.';
				$default = '';
				HeadwayLeafsHelper::create_text_input(array('name' => 'gp-panelbordercolour', 'value' => $leaf['options']['gp-panelbordercolour'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
			
				/* Panel padding */
				$title = 'Frame padding';
				$tooltip = 'Set the frame padding in pixels. Padding is the space between the outer edge and the content.';
				$default = '';
				HeadwayLeafsHelper::create_text_input(array('name' => 'gp-panel-padding', 'value' => $leaf['options']['gp-panel-padding'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		}

		// Panel Width
		$title = 'Frame Width';
		$tooltip = 'Sets the width of the frame in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-frame-width', 'value' => $leaf['options']['gp-frame-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Panel height
		$title = 'Frame Height';
		$tooltip = 'Sets the height of the frame in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-frame-height', 'value' => $leaf['options']['gp-frame-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Use embedded
		$title = 'Use this gallery embedded in the page content. Use [showgalleryplus '.$leaf['id'].']';
		$tooltip = 'If enabled, the gallery can be embedded in the content of your page using the shortcode <strong>[showgalleryplus '.$leaf['id'].']</strong> in your page content. <br/><br/><strong>Note:</strong> The gallery will not appear as a leaf on your page when this checked; however, in the Visual Editor, it will still be shown, so it\'s best to put embedded lefs at the bottom of your pages.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-use-embedded', 'value' => $leaf['options']['gp-use-embedded'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => 'Yes'), $leaf['id']);


	HeadwayLeafsHelper::close_tab();
}

function gp_options_text($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-textlocation'] = 'bottom';
		$leaf['options']['gp-titletextsize'] = '18px';
		$leaf['options']['gp-captiontextsize'] = '12px';
		$leaf['options']['gp-textbgcolour'] = '#000';
		$leaf['options']['gp-textcolour'] = ($leaf['type'] == 'gallery-plus') ? '#fff' : '#444';
		$leaf['options']['gp-hidetext'] = false;
		$leaf['options']['gp-textbgopacity'] = '0.6';
	}

	/// ------------------------------------------------
	// TEXT tab                      -----------------
	/// ------------------------------------------------

	switch ($leaf['type']) {
		case 'gallery-plus':
			$gp_textloc = array(
					'top' => 'Top - in front of images',
					'above' => 'Above images',
					'bottom' => 'Bottom - in front images',
					'below' => 'Below images',
					'none' => 'No text'
				);
			break;

		 case 'gallery-plus-grid':
			$gp_textloc = array(
					'show' => 'Show title',
					'none' => 'Do not show title'
				);
			break;

		 case 'gallery-plus-accordion':
			$gp_textloc = array(
					'show' => 'Show title',
					'none' => 'Do not show title'
				);
			break;

		 case 'gallery-plus-stack':
			$gp_textloc = array(
					'show' => 'Show title',
					'none' => 'Do not show title'
				);
			break;

		 case 'gallery-plus-carousel':
			$gp_textloc = array(
					'show' => 'Show title',
					'none' => 'Do not show title'
				);
			break;
	}
	HeadwayLeafsHelper::open_tab('text', $leaf['id']);

		// Text location
		$title = 'Text location';
		$tooltip = 'Location for image\s title and caption';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-textlocation', 'value' => $leaf['options']['gp-textlocation'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_textloc), $leaf['id']);
	
		// Text colour
		$title = 'Text colour';
		$tooltip = 'Colour of title and caption text in HTML - eg. #FFF = white.<br/>For help choosing HTML colour codes, click the above link to the Colour Code Generator. ';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-textcolour', 'value' => $leaf['options']['gp-textcolour'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


	 if ($leaf['type'] == 'gallery-plus') {
			// Text background color
			$title = 'Text background colour';
			$tooltip = 'Background colour for text area, in HTML - eg. #000 = black.<br/>For help choosing HTML colour codes, click the above link to the Colour Code Generator.';
			$default = '';
			HeadwayLeafsHelper::create_text_input(array('name' => 'gp-textbgcolour', 'value' => $leaf['options']['gp-textbgcolour'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
	
			// Text background opacity
			$title = 'Text background opacity';
			$tooltip = 'Opacity of text background as a value between 0 and 1';
			$default = 'Default: 0.6';
			HeadwayLeafsHelper::create_text_input(array('name' => 'gp-textbgopacity', 'value' => $leaf['options']['gp-textbgopacity'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
	}

		

	HeadwayLeafsHelper::close_tab();
}

function gp_options_images($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-album'] = 'Samples: 98989898';
		$leaf['options']['gp-vertical-crop-align'] = 'center';
		$leaf['options']['gp-horizontal-crop-align'] = 'center';
		$leaf['options']['gp-sizing-type'] = 'crop';		
		$leaf['options']['gp-image-fill'] = '#fff';
		$leaf['options']['gp-quality'] = '70';
		$leaf['options']['gp-start'] =1;
		$leaf['options']['gp-order-az'] = 'ASC';
		$leaf['options']['gp-order-by'] = 'title';
		$leaf['options']['gp-link-to'] = 'lightbox';
		$leaf['options']['gp-recreate-images']	= false;

		$leaf['options']['gp-image-height'] = '400';
		$leaf['options']['gp-image-width'] = '600';



		$leaf['options']['gp-image-borders'] = false;
		$leaf['options']['gp-image-padding'] = 0;


	}

	/// ------------------------------------------------
	// Images tab						   -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('images', $leaf['id']);

		/* Album */
		/* Create a list of all galleries in G+, HW and NG prefixed with their source name */
		$gp_albums = GPFunctions::get_galleries(); // Located in gp_functions.php
		$gp_album_list = array();
		$gp_album_list[0] = 'No gallery selected';
		foreach ($gp_albums as $albums) {
			$gp_album_list[$albums['source'].$albums['post_id']] = $albums['source'].$albums['title'];
		}
		$title = 'Gallery';
		$tooltip = 'Select a gallery of images to display';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-album', 'value' => $leaf['options']['gp-album'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_album_list), $leaf['id']);

		/* Image Width */
		$title = 'Display Image Width';
		$tooltip = 'Set the width in pixels you want to display the main images';
		$default = 'Default: 600';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-image-width', 'value' => $leaf['options']['gp-image-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		
		/* Image height */
		$title = 'Display Image Height';
		$tooltip = 'Set the height in pixels you want to display the main images';
		$default = 'Default: 400';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-image-height', 'value' => $leaf['options']['gp-image-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

	
		/* Vertical crop alignment */
		$vertical_crop_align = array(
				'center' => 'Center',
				'top' => 'Top',
				'topquarter' => 'Top quarter',
				'bottomquarter' => 'Bottom quarter',
				'bottom' => 'Bottom'
			);
		$title = 'Vertical Crop Alignment';
		$tooltip = 'Choose how you want to vertically align the main image when it crops.';
		$default = 'Default: Center';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-vertical-crop-align', 'value' => $leaf['options']['gp-vertical-crop-align'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $vertical_crop_align), $leaf['id']);

		/* Horizontal crop alignment */
		$horizontal_crop_align = array(
				'center' => 'Center',
				'left' => 'Left',
				'leftquarter' => 'Left quarter',
				'rightquarter' => 'Right quarter',
				'right' => 'Right'
			);
		$title = 'Horizontal Crop Alignment';
		$tooltip = 'Choose how you want to horizontally align the main image when it crops';
		$default = 'Default: Center';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-horizontal-crop-align', 'value' => $leaf['options']['gp-horizontal-crop-align'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $horizontal_crop_align), $leaf['id']);

		if ($leaf['type'] == 'gallery-plus') {
			// Crop type
			$sizing_type = array(
					'crop' => 'Crop width and height to fit',
					'exact' => 'Stretch to width and height (Warning: Can distort image)',
					'portrait' => 'Crop width, match height',
					'landscape' => 'Match width, crop height',
					'auto' => 'Fit within width and height'
				);
			$title = 'Image resizing method';
			$tooltip = 'Choose how you want the image resized in respect of its width and height to the Display Image Height and Width';
			$default = 'Default: Crop';
			HeadwayLeafsHelper::create_select(array('name' => 'gp-sizing-type', 'value' => $leaf['options']['gp-sizing-type'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $sizing_type), $leaf['id']);
	
			/* Image fill colour */
			$title = 'Image fill colour';
			$tooltip = 'Choose a fill colour for when an image doesn\'t fully fill the frame';
			$default = 'Default:#fff';
			HeadwayLeafsHelper::create_text_input(array('name' => 'gp-image-fill', 'value' => $leaf['options']['gp-image-fill'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		}

		// Compression
		$title = 'Image quality';
		$tooltip = 'Lower values will reduce the size of the file but also the clarity of the image. Higher values will make images slower loading.<br/>Value range is 0 to 100.';
		$default = 'Default: 70';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-quality', 'value' => $leaf['options']['gp-quality'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		

		if ($leaf['type'] == 'gallery-plus') {
			// Start image
			$title = 'Start at image';
			$tooltip = 'Start at image <em>n</m>';
			$default = '';
			HeadwayLeafsHelper::create_text_input(array('name' => 'gp-start', 'value' => $leaf['options']['gp-start'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		}
		// Order by
		$gp_order_by = array(
				'title' => 'Title',
				'ID' => 'Order added',
				'rand' => 'Random'
			);
		$title = 'Order By';
		$tooltip = 'Set what info you\'d like to order the images by. Note: Some galleries plugins may not support this.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-order-by', 'value' => $leaf['options']['gp-order-by'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_order_by), $leaf['id']);

		// Order
		$gp_order_az = array(
				'ASC' => 'Ascending',
				'DESC' => 'Descending'
			);
		$title = 'Order';
		$tooltip = 'Sets the order of the images, either ascending or descending. Note: Some galleries plugins may not support this.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-order-az', 'value' => $leaf['options']['gp-order-az'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_order_az, 'no-border'=>true), $leaf['id']);

		// Link to
		if ($leaf['type'] == 'gallery-plus') {
		$gp_link_to = array(
				'lightbox' => 'Lightbox',
				'url' => 'URL',
				'none' => 'Do not link'
			);
		
		} else {
		$gp_link_to = array(
				'lightbox' => 'Lightbox',
				'url' => 'URL',
				'zoomup' => 'Zoom up',
				'none' => 'Do not link'
			);
		
		}
		$title = 'Action on image click/hover';
		$tooltip = 'Action on image click/hover. <br/><strong>If you choose URL, you will need to enter the required URL in the descriptiuon field of the images in the selected G+ gallery.</strong>';
		$default = 'Default: Lightbox';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-link-to', 'value' => $leaf['options']['gp-link-to'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_link_to, 'no-border'=>true), $leaf['id']);
		

		// Recreate all images on publish or refresh
		$title = 'Do not recreate images for this leaf';
		$tooltip = 'By default, this leaf\'s images will be recreated when publishing or refreshing in the Visual Editor. <br/>Once you are happy with the images for this leaf, then check this so they don\'t get rereated each time. <br/> This has no effect other than saving the time it takes to reload the Visual Editor.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-recreate-images', 'value' => $leaf['options']['gp-recreate-images'], 'left-label' =>   gp_option_label($title, $tooltip, $default, 'right') , 'checkbox-label' => ''), $leaf['id']);

		if (!function_exists( 'exif_imagetype' )) {	
			echo '<p class="gp-warning"><strong>Note:</strong> Your host\'s server does not have the PHP function exif_imagetype() enabled that is used for image validation. G+ has to use the much slower getimagesize() instead. This might cause the leaf to run noticeably slower.</p>';
		}

	echo '
	<tr>
		<td colspan="2">
			<span class="hilite">If your images are causing an out of memory error, please reduce their size, or increase your system\'s PHP memory limit.<br/>On websites, there is generally no need to have images any larger than 1000x1000px.</span>
		</td>
	</tr>
	';


	HeadwayLeafsHelper::close_tab();

}



function gp_options_lightbox($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-lb-auto'] = true;
		$leaf['options']['gp-lb-circular'] = true;
		$leaf['options']['gp-lb-showfor'] = 5;
		$leaf['options']['gp-lb-style'] = 'default';
		$leaf['options']['gp-lb-background'] = 'black';
		$leaf['options']['gp-lb-bg-opacity'] = 0.9;
		$leaf['options']['gp-lb-social'] = false;

	}

	/// ------------------------------------------------
	// Lightbox tab					   -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('lightbox', $leaf['id']);

		// Auto start
		$title = 'Auto start lighbox slideshow';
		$tooltip = 'Enable this if you wish to automatically start scrolling through the images after the lightbox loads.';
		$default = 'Default: Enabled';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-lb-auto', 'value' => $leaf['options']['gp-lb-auto'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

/*
		// Continous slideshow
		$title = 'Loop back to first in lightbox';
		$tooltip = 'Enable this if you want to go back to the first image after the last one is reached in the lightbox.';
		$default = 'Default: Enabled';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-lb-circular', 'value' => $leaf['options']['gp-lb-circular'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);
*/

		// Show images for...
		$title = 'Show images for <em>n</em> seconds in lightbox';
		$tooltip = 'Sets the time the images display for in the lightbox';
		$default = 'Default:5';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-lb-showfor', 'value' => $leaf['options']['gp-lb-showfor'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

 		// Style
		$lb_style = array(
				'pp_default' => 'Basic',
				'light_rounded' => 'Light frame, rounded corners',
				'dark_rounded' => 'Dark frame, rounded corners',
				'light_square' => 'Light frame, square corners',
				'dark_square' => 'Dark frame, square corners',
				'facebook' => 'Facebook style',
				'plain_black' => 'Plain black',
				'plain_white' => 'Plain white'
			);
		$title = 'Style for lightbox display';
		$tooltip = 'Choose the style you want to use to display the lightbox';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-lb-style', 'value' => $leaf['options']['gp-lb-style'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $lb_style), $leaf['id']);

 		// Background
		$lb_background = array(
				'#000000' => 'Black',
				'#808080' => 'Grey',
				'#ffffff' => 'White'
			);
		$title = 'Background color for lightbox display';
		$tooltip = 'Choose the background colour you want to use behind the lightbox';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-lb-background', 'value' => $leaf['options']['gp-lb-background'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $lb_background), $leaf['id']);

		// Bacground opacity
		$title = 'Background opacity';
		$tooltip = 'Set the opacity of the lightbox background';
		$default = 'Default:0.9';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-lb-bg-opacity', 'value' => $leaf['options']['gp-lb-bg-opacity'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		
/*
		// Social buttons
		$title = 'Show Twitter and Facebook buttons';
		$tooltip = 'Enable this if you want viewers to be able to Like or Tweet your images.';
		$default = 'Default: Off';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-lb-social', 'value' => $leaf['options']['gp-lb-social'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);
*/
	

	HeadwayLeafsHelper::close_tab();
}

function gp_options_css3($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-image-shadows'] = true;
		$leaf['options']['gp-gallery-shadow'] = 'bottomright';
		$leaf['options']['gp-gallery-shadow-depth'] = '3';
		$leaf['options']['gp-gallery-shadow-spread'] = '10';
		$leaf['options']['gp-gallery-shadow-colour'] = '#999999';
		$leaf['options']['gp-gallery-shadow-inset']	= false;	
		$leaf['options']['gp-leaf-style'] = 'none';
	}

	/// ------------------------------------------------
	// CSS3 tab						   -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('css3', $leaf['id']);
	echo '
	<tr>
		<td colspan="2">
			CSS3 Enhancements will only show up in modern browsers. The only versions of Internet Explorer that will show them is IE9 or above. Viewers of your site using IE8 or less will not enjoy the spiffiness.<br/>
		</td>
	</tr>
	';

		// Gallery shadow
		$gp_gallery_shadow = array(
				'topleft' => 'Top left',
				'topright' => 'Top right',
				'bottomleft' => 'Bottom left',
				'bottomright' => 'Bottom right',
				'centered' => 'Centered',
				'none' => 'None'
				
			);
		$title = 'Gallery shadow';
		$tooltip = 'Choose location of the gallery\'s shadow if you want one.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-gallery-shadow', 'value' => $leaf['options']['gp-gallery-shadow'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_gallery_shadow), $leaf['id']);

 		// Gallery shadow depth
		$title = 'Gallery shadow depth (px)';
		$tooltip = 'Set how far behind the frame you want the shadow to seem to be.';
		$default = 'Default: 5';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-gallery-shadow-depth', 'value' => $leaf['options']['gp-gallery-shadow-depth'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

 		// Gallery shadows blur
		$title = 'Gallery shadow blur (px)';
		$tooltip = 'Set this to blur the shadow more. A setting of 0 will have a sharp edged shadow.';
		$default = 'Default: 5';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-gallery-shadow-spread', 'value' => $leaf['options']['gp-gallery-shadow-spread'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Gallery shadows colour
		$title = 'Gallery shadow colour';
		$tooltip = 'Generally use a shade of grey. #999999 is reasonable medium. <br/>However, if your background is coloured, you will need to use a darker shader of it. e.g if your background is #bbbb00, then use say #777700';
		$default = 'Default: #999999';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-gallery-shadow-colour', 'value' => $leaf['options']['gp-gallery-shadow-colour'], 'label' =>   gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		$title = 'Inset gallery shadow';
		$tooltip = 'Show the shadow inside the frame, giving an inset appearance rather than outside the frame givig a raised appearance';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-gallery-shadow-inset', 'value' => $leaf['options']['gp-gallery-shadow-inset'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		 if ($leaf['type'] == 'gallery-plus') {
	 		// Rotate Gallery
			$title = 'Rotate gallery (deg)';
			$tooltip = 'Just for something a little different and crazy. If you use it, make sure you create space around the gallery as it could overlap.<br/>Don\'t overdo it either, 1 degree is quite a large angle.<br/>Rotation works best when you don\'t have thumbs or a nav bar.<p class="hilite">Use a minus sign for reverse rotations. E.g. -1</p>';
			$default = '';
			HeadwayLeafsHelper::create_text_input(array('name' => 'gp-gallery-rotate', 'value' => $leaf['options']['gp-gallery-rotate'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		}
/*
		// Leaf styles
		$gp_leaf_styles = array(
				'gpls1' => '1',
				'gpls2' => '2',
				'gpls3' => '3',
				'gpls4' => '4',
				'gpls5' => '5',
				'none' => 'None'
				
			);
		$title = 'Leaf style';
		$tooltip = 'Choose a predefined style for the leaf';
		$default = 'Default: none';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-leaf-style', 'value' => $leaf['options']['gp-leaf-style'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_leaf_styles), $leaf['id']);
*/


	HeadwayLeafsHelper::close_tab();

	// ------------------------------------------------
	// MESSAGES tab                      -----------------
	// ------------------------------------------------
/*
		$leaf['options']['gp-msg-insufficient-images'] = 'Insufficient images in selected gallery. Please add some or select another gallery';
	HeadwayLeafsHelper::open_tab('messages', $leaf['id']);

		

		// Insufficient images 
		$title = 'Insufficient Images in Post';
		$tooltip = '';
		$default = 'Default: Insufficient images in selected gallery. Please add some or select another gallery';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-msg-insufficient-images', 'value' => $leaf['options']['gp-msg-insufficient-images'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


	HeadwayLeafsHelper::close_tab();
*/

}

function gp_options_misc($leaf) {
	if($leaf['new']){
		$leaf['config']['show-title'] = true;		
/* 		$leaf['options']['gp-memory-limit'] = 'none'; */
	}

	/// ------------------------------------------------
	// MISCELLANEOUS tab (standard HW) -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('miscellaneous', $leaf['id']);
	echo '
	<tr>
		<td colspan="2">
			<small style="float:right;padding:right:5px;"><em>Gallery+ v'.GP_VERSION.'</em></small>
		</td>
	</tr>
	';

	HeadwayLeafsHelper::create_show_title_checkbox($leaf['id'], $leaf['config']['show-title']);
	HeadwayLeafsHelper::create_title_link_input($leaf['id'], $leaf['config']['title-link']);
	HeadwayLeafsHelper::create_classes_input($leaf['id'], $leaf['config']['custom-classes'], true);

/*
	$title = 'Restrict memory';
	$tooltip = 'If images aren\'t displaying or you are getting an out of memory error, try changing how much memory G+ will use';
	$default = '';
	$gp_memory_limit = array(
			'none' => 'Off',
			'16M' => '16MB',
			'32M' => '32MB',
			'48M' => '48MB',
			'64M' => '64MB'				
		);
	HeadwayLeafsHelper::create_select(array('name' => 'gp-memory-limit', 'value' => $leaf['options']['gp-memory-limit'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_memory_limit), $leaf['id']);
*/

	echo '
	
	<tr>
		<td colspan="2">
			<small style="float:right;padding:right:5px;">PHP memory limit: '.ini_get('memory_limit').'</small>
		
	</td>
	</tr>
	';

/* 			<small style="float:right;padding:right:5px;">WP memory limit: '.WP_MEMORY_LIMIT.'</small><br/> */
		
	HeadwayLeafsHelper::close_tab();

	echo '<p class="gp-user-guide"><a href="'.GPUSERGUIDE.'" target=_blank>Open Gallery+ user guide</a></p>';
}

function gp_option_label($title, $tooltip, $default,$posi) {
	return $title.'<a class="gp-tooltip '.$posi.'"><img src="'.(WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))).'/media/images/question2.jpg"><span class="vised"><strong>'.$title.':</strong> '.$tooltip.'<br/><em>'.$default.'</em></span></a>';
}



