<?php
function gp_leaf_options_carousel($leaf){
	/* Set default values */

	$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	$show_tabs = array();
		
		$display = 	array(
			'images' => 'Images',
			'frame' =>	'Frame',
			'thumbs' => 'Thumbnails',
			'text' => 'Titles',
			'lightbox' => 'Lightbox',
			'css3' => 'CSS3 Styling',
			'miscellaneous' => 'Miscellaneous'
		);

		HeadwayLeafsHelper::create_tabs($display, $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<a href="'.GP_COLOUR_PICKER.'" target=_blank>Online Color Code Generator Tool</a><br />
		</td>
	</tr>';

	$leaf['type'] = 'gallery-plus-carousel';

	gp_options_images($leaf);	
	gp_options_frame($leaf);	
	gp_options_carousel_thumbs($leaf);	
	gp_options_text($leaf);	
	gp_options_lightbox($leaf);	
	gp_options_css3($leaf);	
	gp_options_misc($leaf);	

}

/*

Functions:
	gp_initialize_gallery_plugins($leaf)
	gp_build_gallery($leaf)
	gp_scripts_gallery($leaf)

This file calls the code for the galleries.

As new gallery styles are added, this folder will be updated.

*/



function gp_build_carousel_gallery($leaf) {
	$return_html = '';
	// this will be switch:cased
	$gp_selected_gallery = $leaf['options']['gp-album'];
	$gp_using_source = substr($leaf['options']['gp-album'],0,7);
	if ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] && $leaf['options']['gp-auto']) {
		$leaf['options']['gp-shownavitems'] = 0;	
	}

	$gp_images = false;
	$gp_gallery_fail = 'insufficient_images';

	$gp_process = GPFunctions::process_gallery($leaf,$gp_using_source);
	$gp_selected_gallery = $gp_process[0]; 
	$gp_images = $gp_process[1];
	$gp_source_id = $gp_process[2];
	$gp_gallery_fail = $gp_process[3];

	
	$gp_no_caption = (!$gp_data['caption'])  ? ' no-caption ' : '';	
	$gp_gallery_source = $gp_source_id.$gp_selected_gallery;


	if (!$gp_images) {return '<div id="grid-gallery-'.$leaf['id'].'">No image in selected gallery. Please add some or select another gallery</div>';}
	

	$carousel_width = $leaf['options']['gp-frame-width'];
	$carousel_height = $leaf['options']['gp-frame-height'];

	$grid_width_css = (!$leaf['options']['gp-scroll-thumbs-hz']) ? '' : 'width:'.(($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding'])* sizeof($gp_images)).'px;overflow-x:auto;';
	
	$gp_type = '';
	$gp_navpos = '';
	$gp_movepanel = '';
	$gp_movetext = '';
	$gp_height ='';
	$gp_nav_width_css = '';
	$gp_nav_width = 95;
	$gp_prev_loc ='';
	$gp_next_loc = '';
	$gp_rev = (!$leaf['options']['gp-invert-buttons']) ? '' : ' rev';
	$thumb_id= 0;
	$image_id = 0;
	$gp_thumb_padding_val = (!$leaf['options']['gp-pad-between-thumbs']) ? 0 : ($leaf['options']['gp-panel-padding']/2);
	$gp_thumb_padding = 'padding:'.$gp_thumb_padding_val.'px;';



	$return_html .= '<div id="carousel-gallery-'.$leaf['id'].'" class="carousel-gallery-set" style="height:'.$carousel_height.'px;width:'.$carousel_width.'px;">';
					foreach ($gp_images as $gp_data){
						$thumb_id++;
						$thumb_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-thumb-width'], $leaf['options']['gp-thumb-height'], 'center','center',$gp_source_id.'thm'.$thumb_id, $leaf['id'],'crop',$leaf['options']['gp-quality'],$leaf['options']['gp-panelbgcolour'],false);
		switch($leaf['options']['gp-link-to']) {

			case 'lightbox':
	$return_html .= '		<a href="'.$gp_data['image_url'].'" rel="prettyPhoto-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.str_replace('"','&#8221;',$gp_data['caption']).'">';
	$return_html .= '			<img class="cloudcarousel" src="'.$thumb_src['new_image_url'].'"  title="'.$gp_data['title'].'" alt="'.$gp_data['caption'].'"/>';
	$return_html .= '		</a>';
				break;

			case 'url':
	$return_html .= '		<a href="'.$gp_data['link_url'].'" rel="image-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
	$return_html .= '			<img class="cloudcarousel" src="'.$thumb_src['new_image_url'].'"  title="'.$gp_data['title'].'" alt="'.$gp_data['caption'].'"/>';
	$return_html .= '		</a>';
				break;

			case 'zoomup':
				$image_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-image-width'], $leaf['options']['gp-image-height'], 'center','center',$gp_source_id.'img'.$thumb_id, $leaf['id'],'auto',$leaf['options']['gp-quality'],"#fff",true);

	$return_html .= '			<img src="'.$thumb_src['new_image_url'].'"  title="'.$gp_data['title'].'"alt="'.$gp_data['caption'].'" rel="#zoomup-'.$leaf['id'].'-'.$thumb_id.'" class="cloudcarousel zoomup"/>';

	$return_html .= '		<div id="zoomup-'.$leaf['id'].'-'.$thumb_id.'" class="clean_overlay" style="width:'.$leaf['options']['gp-image-width'].'">';	
	$return_html .= '			<img src="'.$image_src['new_image_url'].'"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3><span class="zoomup-caption">'.$gp_data['caption'].'</span>';
	
						}
	$return_html .= '		</div>';
	
				break;


			case 'none':
	$return_html .= '			<img class="cloudcarousel" src="'.$thumb_src['new_image_url'].'"  title="'.$gp_data['title'].'" alt="'.$gp_data['caption'].'"/>';
				break;
		}	//end switch			
	} // end foreach

		if ($leaf['options']['gp-textlocation'] == 'show') {
   $return_html .= '		<div class="itemtext">
	        <!-- Define elements to accept the alt and title text from the images. -->
	        <h3 id="title-text"  style="color:'.$leaf['options']['gp-textcolour'].';">'.$gp_data['title'].'</h3>
	        <p id="alt-text"  style="color:'.$leaf['options']['gp-textcolour'].';">'.$gp_data['caption'].'</p>
	    </div>';
	}    
	$return_html .= '	<div class="navscroller">
	        <div id="left-but"></div>
	        <div id="right-but"></div>
		</div>
       ';


	$return_html .= '</div>';	
	

	return $return_html;
}

function gp_scripts_gallery_carousel($leaf){
	$return_js = "";
	

	$gp_xpos = $leaf['options']['gp-frame-width']/2;
	$gp_ypos = $leaf['options']['gp-frame-height']/2;
	$gp_delay = $leaf['options']['gp-carousel-autorotatedelay']*1000;

	$return_js .= "	
		jQuery(document).ready(function(){
			jQuery('#carousel-gallery-".$leaf['id']."').CloudCarousel(		
				{			
					xPos: ".$gp_xpos.",
					yPos: 40,
					buttonLeft: jQuery('#left-but'),
					buttonRight: jQuery('#right-but'),
					altBox: jQuery('#alt-text'),
					titleBox: jQuery('#title-text'),
					reflHeight: ".$leaf['options']['gp-thumb-reflection-height'].",
					reflOpacity: ".$leaf['options']['gp-thumb-reflection-opacity'].",
					minScale: ".$leaf['options']['gp-thumb-scale'].",
					bringToFront: true,
					autoRotate: '".$leaf['options']['gp-carousel-autorotate']."',
					autoRotateDelay: ".$gp_delay."
				}
			);
		});	
	";

	$return_js .= "
		jQuery(window).load(function (){
			jQuery('.carousel-gallery-set img[rel]').overlay();
		});";
	
	// Other js
	
	if ($leaf['options']['gp-link-to'] == 'lightbox') {	
		// prettyPhoto js
		$gp_lb_auto =  ($leaf['options']['gp-lb-auto'] != false) ? 'true' : 'false';
	//	$gp_lb_circular = ($leaf['options']['gp-lb-circular'] != false) ? 'true' : 'false';
		$gp_lb_showfor = ($leaf['options']['gp-lb-showfor']*1000);
		$gp_lb_style = (!$leaf['options']['gp-lb-style']) ? 'pp_default' : $leaf['options']['gp-lb-style'];
	
		$social_code = '<div class="pp_social"><div class="twitter"><a href="http://twitter.com/share" class="twitter-share-button" data-count="none">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div><div class="facebook"><iframe src="http://www.facebook.com/plugins/like.php?locale=en_US&href=\'+location.href+\'&amp;layout=button_count&amp;show_faces=true&amp;width=500&amp;action=like&amp;font&amp;colorscheme=light&amp;height=23" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:500px; height:23px;" allowTransparency="true"></iframe></div></div>';
		$gp_lb_social = ($leaf['options']['gp-lb-social'] != false) ? $social_code : false;
		$gp_lb_style = $leaf['options']['gp-lb-style'];
		$gp_lb_deeplink = ($leaf['options']['gp-lb-social'] != false) ? 'true' : 'false';
		$gp_lb_opacity = $leaf['options']['gp-lb-bg-opacity'];
		$gp_lb_bgcolour = $leaf['options']['gp-lb-background'];
		
	
		$return_js .= " 
				jQuery(document).ready(
					function (){
							jQuery(\"a[rel^='prettyPhoto-".$leaf['id']."']\").prettyPhoto(
								{
									social_tools:'".$gp_lb_social."',
									opacity: '".$gp_lb_opacity."',
									animation_speed: 'normal',
									autoplay_slideshow: ".$gp_lb_auto.",
									deeplinking: ".$gp_lb_deeplink.",
									slideshow:".$gp_lb_showfor.",
									theme:'".$gp_lb_style."',
									backgcolor: '".$gp_lb_bgcolour."'
									
								}
							);
						}
					);
			";
	}	


	return $return_js;
}

/* 	==============================================================================================================================
	 CAROUSEL OPTIONS
	============================================================================================================================== */


	
function gp_options_carousel_thumbs($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-thumb-height'] = '200';
		$leaf['options']['gp-thumb-width'] = '300';
		$leaf['options']['gp-thumb-scale'] = '0.5';
		$leaf['options']['gp-thumb-reflection-height'] = '50';
		$leaf['options']['gp-thumb-reflection-opacity'] = '0.5';
		$leaf['options']['gp-carousel-diameterX'] = '';
		$leaf['options']['gp-carousel-diameterY'] = '';
		$leaf['options']['gp-carousel-autorotate']= 'right';
		$leaf['options']['gp-carousel-autorotatedelay'] = 5;
		$leaf['options']['gp-sizing-type'] ='auto';

	}
	/// ------------------------------------------------
	// CAROUSEL THUMBS tab          -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('thumbs', $leaf['id']);
		// Thumb Width
		$title = 'Front Thumb Width';
		$tooltip = 'Sets the width in pixels for the thumbnail when it is at the front position';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-width', 'value' => $leaf['options']['gp-thumb-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Thumb height
		$title = 'Front Thumb Height';
		$tooltip = 'Sets the height in pixels for the thumbnail when it is at the front position';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-height', 'value' => $leaf['options']['gp-thumb-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Crop type
/*
		$sizing_type = array(
				'crop' => 'Crop width and height to fit',
				'exact' => 'Stretch to width and height (Warning: Can distort image)',
				'portrait' => 'Crop width, match height',
				'landscape' => 'Match width, crop height',
				'auto' => 'Fit within width and height'
			);
		$title = 'Thumb resizing method';
		$tooltip = 'Choose how you want the thumb resized in respect of its width and height to the Thumb Image Height and Width';
		$default = 'Default: Crop';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-sizing-type', 'value' => $leaf['options']['gp-sizing-type'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $sizing_type), $leaf['id']);
*/


		// Thumb scaling
		$title = 'Thumb scaling';
		$tooltip = 'Set the scale of the furtherest away image in the carousel to the frontmost image. (Value between 0 and 1) e.g. 0.25 equals 25% of the size';
		$default = 'Default: 0.25';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-scale', 'value' => $leaf['options']['gp-thumb-scale'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Reflection height
		$title = 'Reflection height';
		$tooltip = 'Set the height of the image reflection. Set to 0 for no reflection';
		$default = 'Default: 50';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-reflection-height', 'value' => $leaf['options']['gp-thumb-reflection-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Thumb height
		$title = 'Reflection opacity';
		$tooltip = 'Set the transparency of the image reflection (Value between 0 and 1)';
		$default = 'Default: 0.5';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-reflection-opacity', 'value' => $leaf['options']['gp-thumb-reflection-opacity'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Auto rotate
		$gp_rotate = array(
			'right' => 'Right',
			'left' => 'Left',
			'no' => 'Off'
		);
		$title = 'Auto rotate';
		$tooltip = 'Option to set direction and enable auto-rotation of the carousel';
		$default = 'Default: Right';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-carousel-autorotate', 'value' => $leaf['options']['gp-carousel-autorotate'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_rotate), $leaf['id']);

		// Rotate delay
		$title = 'Rotate delay';
		$tooltip = 'Time in seconds between each rotation to next image';
		$default = 'Default: 5';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-carousel-autorotatedelay', 'value' => $leaf['options']['gp-carousel-autorotatedelay'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


	HeadwayLeafsHelper::close_tab();

}
