<?php

function gp_leaf_options_galleriffic($leaf){
	/* Set default values */

	$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	$tabs = array();
		
		$tabs = array(
			'images' => 'Images',
			'frame' =>	'Frame',
			'navbuttons' => 'Nav Buttons',
			'navthumbs' => 'Nav Thumbs',
			'text' => 'Text',
			'slideshow' => 'Slideshow',
			'lightbox' => 'Lightbox',
			'css3' => 'CSS3 Styling',
			'miscellaneous' => 'Miscellaneous'
		);
		HeadwayLeafsHelper::create_tabs($tabs, $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<a href="'.GP_COLOUR_PICKER.'" target=_blank>Online Color Code Generator Tool</a><br />
		</td>
	</tr>';
	
	$leaf['type'] = 'gallery-plus';

	gp_options_images($leaf);	
	gp_options_frame($leaf);	
	gp_options_nav_buttons_slider($leaf);	
	gp_options_nav_thumbs_slider($leaf);	
	gp_options_text($leaf);	
	gp_options_slideshow_slider($leaf);	
	gp_options_lightbox($leaf);	
	gp_options_css3($leaf);	
	gp_options_misc($leaf);	

}

/*

*/


// do all enqueue stuff, js, css for each gallery plugged in


function gp_build_galleriffic_gallery($leaf) {
	$return_html = '';
	// this will be switch:cased
	$gp_selected_gallery = $leaf['options']['gp-album'];
	$gp_using_source = substr($leaf['options']['gp-album'],0,7);
	if ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] && $leaf['options']['gp-auto']) {
		$leaf['options']['gp-shownavitems'] = 0;	
	}

	$gp_images = false;
	$gp_gallery_fail = 'insufficient_images';

	$nav_button_css = ';background-image:url('.GP_MEDIA_URL.'/nav-buttons/'.$nav_btn_style.')';

	$gp_process = GPFunctions::process_gallery($leaf,$gp_using_source);
	$gp_selected_gallery = $gp_process[0]; 
	$gp_images = $gp_process[1];
	$gp_source_id = $gp_process[2];
	$gp_gallery_fail = $gp_process[3];
	
	$gp_no_caption = (!$gp_data['caption'])  ? ' no-caption ' : '';	
	$gp_gallery_source = $gp_source_id.$gp_selected_gallery;

/*
	if (!$gp_images) {
		return $gp_gallery_fail;
	}
*/


	if (!$gp_images) {return '<div id="galleriffic-gallery-'.$leaf['id'].'">No image in selected gallery. Please add some or select another gallery</div>';}
	

	$image_width = $leaf['options']['gp-image-width'];
	$image_height = $leaf['options']['gp-image-height'];

	
	$gp_type = '';
	$gp_navpos = '';
	$gp_movepanel = '';
	$gp_movetext = '';
	$gp_height ='';
	$gp_nav_width_css = '';
	$gp_nav_width = 95;
	$gp_prev_loc ='';
	$gp_next_loc = '';
	$gp_rev = (!$leaf['options']['gp-invert-buttons']) ? '' : ' rev';
	$thumb_id= 0;
	$image_id = 0;
	$gp_thumb_padding_val = (!$leaf['options']['gp-pad-between-thumbs']) ? 0 : ($leaf['options']['gp-panel-padding']/2);
	

	$return_html .= '
					<div id="gallery" class="content">
   						<div id="controls" class="controls"></div>
   						<div class="slideshow-container">
   							<div id="loading" class="loader"></div>
   							<div id="slideshow" class="slideshow"></div>
   						</div>
   						<div id="caption" class="caption-container"></div>
   					</div>

			<div id="thumbs-'.$leaf['id'].'" class="navigation">
			    <ul class="thumbs noscript">';
					foreach ($gp_images as $gp_data){
						$thumb_id++;
						$thumb_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-thumb-width'], $leaf['options']['gp-thumb-height'], 'center','center',$gp_source_id.'thm'.$thumb_id, $leaf['id'],'crop',$leaf['options']['gp-quality'],$leaf['options']['gp-panelbgcolour'],false);
						$image_id++;
						$image_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $image_width, $image_height, $leaf['options']['gp-vertical-crop-align'],$leaf['options']['gp-horizontal-crop-align'],$gp_source_id.'img'.$image_id, $leaf['id'],$leaf['options']['gp-sizing-type'],$leaf['options']['gp-quality'],$leaf['options']['gp-image-fill'],true);

	$return_html .= '  <li>
			            <a class="thumb" href="'.$image_src['new_image_url'].'" title="'.$gp_data['title'].'">
			                <img src="'.$thumb_src['new_image_url'].'" alt="'.$gp_data['title'].'" />
			            </a>
			            <div class="caption">
			                
			                <div class="image-title">'.$gp_data['title'].'</div>
			                <div class="image-desc">'.$gp_data['caption'].'</div>
			            </div>
			        </li>';
				}
	$return_html .= '   </ul>
			</div>
	';
	



	return $return_html;
}




function gp_scripts_gallery_galleriffic($leaf){
	
	// galleriffic variables
	$return_js = "";
	$gp_start   = ($leaf['options']['gp-start'] == 0) ? 0 : ($leaf['options']['gp-start']-1);
	$gp_auto   = ($leaf['options']['gp-auto'] != false) ? 'true' : 'false';
	$gp_autospeed  = $leaf['options']['gp-autospeed']*1000;
	$gp_mousewheel  = ($leaf['options']['gp-mousewheel'] != false) ? 'true' : 'false';
	$gp_keyboard  = ($leaf['options']['gp-keyboard'] != false) ? 'true' : 'false';
	$gp_panelclick  = ($leaf['options']['gp-panelclick'] != false) ? 'true' : 'false';
	$gp_circular  = ($leaf['options']['gp-circular'] != false) ? 'true' : 'false';
	$gp_shownavitems = ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] || !$leaf['options']['gp-shownavitems']) ? 0 : $leaf['options']['gp-shownavitems'];
	$gp_navitemshover = ($leaf['options']['gp-navitemshover'] != false) ? 'true' : 'false';
	$gp_navclipcenter = ($leaf['options']['gp-navclipcenter'] != false) ? 'true' : 'false';
	$gp_navfx   = $leaf['options']['gp-navfx'];
	$gp_scroll   = $leaf['options']['gp-scroll'];
	$gp_scrollspeed  = $leaf['options']['gp-scrollspeed']*1000;
	$gp_scrolleasing = $leaf['options']['gp-scrolleasing'];
	$gp_panelfx   = $leaf['options']['gp-panelfx'];
	$gp_panelfxspeed = $leaf['options']['gp-panelfxspeed']*1000;
	$gp_panelfxeasing = $leaf['options']['gp-panelfxeasing'];
	$gp_panelbtnshover = ($leaf['options']['gp-panelbtnshover'] != false) ? 'true' : 'false';
	$gp_verticalnav  = ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right') ? 'true' : 'false';
	$gp_verticalslide = ($leaf['options']['gp-verticalslide'] != false) ? 'true' : 'false';
	$gp_fastchange  = ($leaf['options']['gp-fastchange'] != false) ? 'true' : 'false';
	$gp_scrollatend  = ($leaf['options']['gp-circular'] != false) ? 'true' : 'false';


	// galleriffic js
	$return_js = "
jQuery(document).ready(function($) {
    var gallery = jQuery('#thumbs-".$leaf['id']."').galleriffic({
        delay:                     3000, // in milliseconds
        numThumbs:                 20, // The number of thumbnails to show page
        preloadAhead:              40, // Set to -1 to preload all images
        enableTopPager:            false,
        enableBottomPager:         true,
        maxPagesToShow:            7,  // The maximum number of pages to display in either the top or bottom pager
        imageContainerSel:         '', // The CSS selector for the element within which the main slideshow image should be rendered
        controlsContainerSel:      '', // The CSS selector for the element within which the slideshow controls should be rendered
        captionContainerSel:       '', // The CSS selector for the element within which the captions should be rendered
        loadingContainerSel:       '', // The CSS selector for the element within which should be shown when an image is loading
        renderSSControls:          true, // Specifies whether the slideshow's Play and Pause links should be rendered
        renderNavControls:         true, // Specifies whether the slideshow's Next and Previous links should be rendered
        playLinkText:              'Play',
        pauseLinkText:             'Pause',
        prevLinkText:              'Previous',
        nextLinkText:              'Next',
        nextPageLinkText:          'Next &rsaquo;',
        prevPageLinkText:          '&lsaquo; Prev',
        enableHistory:             false, // Specifies whether the url's hash and the browser's history cache should update when the current slideshow image changes
        enableKeyboardNavigation:  true, // Specifies whether keyboard navigation is enabled
        autoStart:                 false, // Specifies whether the slideshow should be playing or paused when the page first loads
        syncTransitions:           false, // Specifies whether the out and in transitions occur simultaneously or distinctly
        defaultTransitionDuration: 1000, // If using the default transitions, specifies the duration of the transitions
        onSlideChange:             undefined, // accepts a delegate like such: function(prevIndex, nextIndex) { ... }
        onTransitionOut:           undefined, // accepts a delegate like such: function(slide, caption, isSync, callback) { ... }
        onTransitionIn:            undefined, // accepts a delegate like such: function(slide, caption, isSync) { ... }
        onPageTransitionOut:       undefined, // accepts a delegate like such: function(callback) { ... }
        onPageTransitionIn:        undefined, // accepts a delegate like such: function() { ... }
        onImageAdded:              undefined, // accepts a delegate like such: function(imageData, $li) { ... }
        onImageRemoved:            undefined  // accepts a delegate like such: function(imageData, $li) { ... }
    });
});
		";
	
	// Other js
	
	if ($leaf['options']['gp-link-to'] == 'lightbox') {	
		// prettyPhoto js
		$gp_lb_auto =  ($leaf['options']['gp-lb-auto'] != false) ? 'true' : 'false';
	//	$gp_lb_circular = ($leaf['options']['gp-lb-circular'] != false) ? 'true' : 'false';
		$gp_lb_showfor = ($leaf['options']['gp-lb-showfor']*1000);
		$gp_lb_style = (!$leaf['options']['gp-lb-style']) ? 'pp_default' : $leaf['options']['gp-lb-style'];
	
		$social_code = '<div class="pp_social"><div class="twitter"><a href="http://twitter.com/share" class="twitter-share-button" data-count="none">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div><div class="facebook"><iframe src="http://www.facebook.com/plugins/like.php?locale=en_US&href=\'+location.href+\'&amp;layout=button_count&amp;show_faces=true&amp;width=500&amp;action=like&amp;font&amp;colorscheme=light&amp;height=23" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:500px; height:23px;" allowTransparency="true"></iframe></div></div>';
		$gp_lb_social = ($leaf['options']['gp-lb-social'] != false) ? $social_code : false;
		$gp_lb_style = $leaf['options']['gp-lb-style'];
		$gp_lb_deeplink = ($leaf['options']['gp-lb-social'] != false) ? 'true' : 'false';
		$gp_lb_opacity = $leaf['options']['gp-lb-bg-opacity'];
		$gp_lb_bgcolour = $leaf['options']['gp-lb-background'];
		
	
		$return_js .= " 
				jQuery(document).ready(
					function (){
							jQuery(\"a[rel^='prettyPhoto-".$leaf['id']."']\").prettyPhoto(
								{
									social_tools:'".$gp_lb_social."',
									opacity: '".$gp_lb_opacity."',
									animation_speed: 'normal',
									autoplay_slideshow: ".$gp_lb_auto.",
									deeplinking: ".$gp_lb_deeplink.",
									slideshow:".$gp_lb_showfor.",
									theme:'".$gp_lb_style."',
									backgcolor: '".$gp_lb_bgcolour."'
									
								}
							);
						}
					);
			";
	}	


	return $return_js;
}
/* 	==============================================================================================================================
	 galleriffic OPTIONS
	============================================================================================================================== */

function gp_options_nav_thumbs_galleriffic($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-shownavitems'] = 3;
		$leaf['options']['gp-scroll'] =3;
		$leaf['options']['gp-navitemshover'] = false;
		$leaf['options']['gp-thumb-height'] = '60';
		$leaf['options']['gp-thumb-width'] = '90';
		$leaf['options']['gp-pad-between-thumbs'] = true;
		$leaf['options']['gp-navclipcenter'] = true;
	}

	/// ------------------------------------------------
	// NAVIGATION THUMBS tab          -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('navthumbs', $leaf['id']);

		// Number thumbs to show
		$title = 'Show <em>n</em> thumbnails (0 to hide)';
		$tooltip = 'Number of thumbnails to show in the navigation bar. ';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-shownavitems', 'value' => $leaf['options']['gp-shownavitems'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// No thumbs to scroll in nav
		$title = 'Skip <em>n</em> images';
		$tooltip = 'Sets how many images to skip when the back/forward navigation buttons are clicked';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-scroll', 'value' => $leaf['options']['gp-scroll'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


		// Scroll on hover
		$title = 'Scroll images on hover over thumbs';
		$tooltip = 'When selected, the images will automatically scrool to the one you hover the mouse over.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-navitemshover', 'value' => $leaf['options']['gp-navitemshover'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Thumb Width
		$title = 'Thumb Width';
		$tooltip = 'Sets the width of the thumbnails in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-width', 'value' => $leaf['options']['gp-thumb-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Thumb height
		$title = 'Thumb Height';
		$tooltip = 'Sets the height of the thumbnails in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-height', 'value' => $leaf['options']['gp-thumb-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Add padding betweem thumbs
		$title = 'Add padding between thumbnails';
		$tooltip = 'This will create space between your thumbnails equivalent to the padding you\'ve selected for your frame';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-pad-between-thumbs', 'value' => $leaf['options']['gp-pad-between-thumbs'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Center nav
		$title = 'Centre thumbs in navigation';
		$tooltip = 'Turn this off if you want the thumbnails to fill the full width or height of the navigation bar.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-navclipcenter', 'value' => $leaf['options']['gp-navclipcenter'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);


	HeadwayLeafsHelper::close_tab();

}

function gp_options_nav_buttons_galleriffic($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-nav-pos'] = 'bottom';
		$leaf['options']['gp-nav-style'] = 'btn0-black-circle-00.png';
		$leaf['options']['gp-invert-buttons'] = false;
		$leaf['options']['gp-panelbtnshover'] = false;
		$leaf['options']['gp-showbackfwdnav'] = true;
	}
	/// ------------------------------------------------
	// NAVIGATION BUTTONS tab          -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('navbuttons', $leaf['id']);

		$gp_navpos = array(
				'top' => 'Top',
				'bottom' => 'Bottom',
				'left' => 'Left',
				'right' => 'Right',
				'none' => 'Do not show'
			);

		// Nav position
		$title = 'Navigation position';
		$tooltip = 'Position within the frame where you want to display the navigation bar, which includes buttons and thumbnails.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-nav-pos', 'value' => $leaf['options']['gp-nav-pos'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_navpos), $leaf['id']);


		$gp_nav_dir = scandir(GP_MEDIA_PATH.'/nav-buttons');
		if (!$gp_nav_dir) {
			$nav_btn_view = 'The nav button images folder is not accessible. Please check its permissions.';
			$gp_nav_buttons['none'] = 'No nav buttons found';
		} else {
			$inc = 0;
			$gp_nav_buttons = array();
			$gp_nav_buttons_img = array();
			
			$nav_btn_view = '';
			foreach ($gp_nav_dir as $nav_file) {
				if (substr($nav_file,0,3) == 'btn') {
					$search = array('/btn\w*-/','/\.\w*/','/-|_/');
					$replace = array('','',' ');
					$nav_btn_text = preg_replace($search,$replace,$nav_file);			
					$gp_nav_buttons[$nav_file] = ucwords($nav_btn_text);
					$nav_btn_view .= '<div class="gp-nav-btn-samples" style="background-image:url('.GP_MEDIA_URL.'/nav-buttons/'.$nav_file.')"><span style="background-color:'.$leaf['options']['gp-panelbgcolour'].'!important;"><img src="'.GP_LEAF_URL.'/images/nav-buttons/'.$nav_file.'"/><br/><br/><strong>'.ucwords($nav_btn_text).'</strong></span></div>';
				}
			}
		}

		echo '<tr>';
		echo '		<th scope="row"><label for="'.$leaf['id'].'_categories">Navigation button samples</label></th>';
		echo '		<td>';
		echo 			$nav_btn_view;
		echo '		</td>';
		echo '	</tr>';

		// Nav style
		$title = 'Navigation style<br/>See samples above';
		$tooltip = 'Choose the style of navigation buttons you want to use in the navigation bar.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-nav-style', 'value' => $leaf['options']['gp-nav-style'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_nav_buttons), $leaf['id']);

		// Invert buttons
		$title = 'Invert button colours';
		$tooltip = 'When selected, the buttons will be swapped to use what would notmally be their hover appearance.This doubles the button options available';
		$default = 'Default: No';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-invert-buttons', 'value' => $leaf['options']['gp-invert-buttons'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Panel nav hover
		$title = 'Show next/previous image buttons on hover over images, not in nav bar';
		$tooltip = 'Turn this off if you\'d like to display the next/previous navigation buttons when you mouse over the image instead of in the navigation bar.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-panelbtnshover', 'value' => $leaf['options']['gp-panelbtnshover'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Show back forward
		$title = 'Show back/forward a page buttons';
		$tooltip = 'Back/forward buttons skip back or forward the number of iamges specified in the \'Skip n images\' setting above.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-showbackfwdnav', 'value' => $leaf['options']['gp-showbackfwdnav'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);



	HeadwayLeafsHelper::close_tab();

}

function gp_options_slideshow_galleriffic($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-auto'] = false;
		$leaf['options']['gp-circular'] = true;
		$leaf['options']['gp-autospeed'] = 4;
		$leaf['options']['gp-panelfxspeed']= 2;
		$leaf['options']['gp-fastchange'] = true;

		$leaf['options']['gp-mousewheel'] = false;
		$leaf['options']['gp-keyboard'] = false;
		$leaf['options']['gp-panelclick'] = false;
		$leaf['options']['gp-scroll'] = 3;
		$leaf['options']['gp-scrollspeed'] = 1;
		$leaf['options']['gp-scrolleasing'] = 'swing';
		$leaf['options']['gp-panelfx'] = 'fading';
		$leaf['options']['gp-panelfxeasing']= 'swing';
		$leaf['options']['gp-verticalslide'] = false;
	}
	/// ------------------------------------------------
	// Slides SETTINGS tab             -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('slideshow', $leaf['id']);

		// Auto start
		$title = 'Auto start slideshow';
		$tooltip = 'Enable this if you wish to automatically start scrolling through the images after the pages loads.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-auto', 'value' => $leaf['options']['gp-auto'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Continous slideshow
		$title = 'Loop back to first';
		$tooltip = 'Enable this if you want to go back to the first image after the last one.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-circular', 'value' => $leaf['options']['gp-circular'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Show images for...
		$title = 'Show images for <em>n</em> seconds';
		$tooltip = 'Sets the time the images display for';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-autospeed', 'value' => $leaf['options']['gp-autospeed'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

 		// Tranisition speed
		$title = 'Transition speed';
		$tooltip = 'Sets the time it takes to change from one image to the next';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-panelfxspeed', 'value' => $leaf['options']['gp-panelfxspeed'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Fast change
		$title = 'Fast change';
		$tooltip = 'When enabled, will change to next image straight away instead of waiting for current one to load when using navigation buttons.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-fastchange', 'value' => $leaf['options']['gp-fastchange'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);


		
	HeadwayLeafsHelper::close_tab();
}

