<?php
function gp_leaf_options_grid($leaf){
	/* Set default values */

	$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	$show_tabs = array();
		
		$display = 	array(
			'images' => 'Images',
			'frame' =>	'Frame',
			'gridthumbs' => 'Thumbnails',
			'text' => 'Titles',
			'lightbox' => 'Lightbox',
			'css3' => 'CSS3 Styling',
			'miscellaneous' => 'Miscellaneous'
		);

		HeadwayLeafsHelper::create_tabs($display, $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<a href="'.GP_COLOUR_PICKER.'" target=_blank>Online Color Code Generator Tool</a><br />
		</td>
	</tr>';
	$leaf['type'] = 'gallery-plus-stack';

	gp_options_images_grid($leaf);	
	gp_options_frame($leaf);	
	gp_options_grid_thumbs($leaf);	
	gp_options_text($leaf);	
	gp_options_lightbox($leaf);	
	gp_options_css3($leaf);	
	gp_options_misc($leaf);	

}



function gp_build_grid_gallery($leaf) {
	$return_html = '';
	// this will be switch:cased
	$gp_selected_gallery = $leaf['options']['gp-album'];
	$gp_using_source = substr($leaf['options']['gp-album'],0,7);
	if ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] && $leaf['options']['gp-auto']) {
		$leaf['options']['gp-shownavitems'] = 0;	
	}

	$gp_images = false;
	$gp_gallery_fail = 'insufficient_images';

	$gp_process = GPFunctions::process_gallery($leaf,$gp_using_source);
	$gp_selected_gallery = $gp_process[0]; 
	$gp_images = $gp_process[1];
	$gp_source_id = $gp_process[2];
	$gp_gallery_fail = $gp_process[3];

	
	$gp_no_caption = (!$gp_data['caption'])  ? ' no-caption ' : '';	
	$gp_gallery_source = $gp_source_id.$gp_selected_gallery;


	if (!$gp_images) {return '<div id="grid-gallery-'.$leaf['id'].'">No image in selected gallery. Please add some or select another gallery</div>';}
	

	$image_width = $leaf['options']['gp-image-width'];
	$image_height = $leaf['options']['gp-image-height'];

	$grid_width_css = (!$leaf['options']['gp-scroll-thumbs-hz']) ? '' : 'width:'.(($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding'])* sizeof($gp_images)).'px;overflow-x:auto;';
	
	$gp_type = '';
	$gp_navpos = '';
	$gp_movepanel = '';
	$gp_movetext = '';
	$gp_height ='';
	$gp_nav_width_css = '';
	$gp_nav_width = 95;
	$gp_prev_loc ='';
	$gp_next_loc = '';
	$gp_rev = (!$leaf['options']['gp-invert-buttons']) ? '' : ' rev';
	$thumb_id= 0;
	$image_id = 0;
	$gp_thumb_padding_val = (!$leaf['options']['gp-pad-between-thumbs']) ? 0 : ($leaf['options']['gp-panel-padding']/2);
	$gp_thumb_padding = 'padding:'.$gp_thumb_padding_val.'px;';

	//Build lightbox settings
	$return_html .= '<div id="grid-gallery-'.$leaf['id'].'" class="clearfix">';
	$return_html .= '<ul class="grid-thumb" style="'.$grid_width_css.'">';
					foreach ($gp_images as $gp_data){
						$thumb_id++;
						$thumb_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-thumb-width'], $leaf['options']['gp-thumb-height'], $leaf['options']['gp-thumb-vertical-crop-align'],$leaf['options']['gp-thumb-horizontal-crop-align'],$gp_source_id.'thm'.$thumb_id, $leaf['id'],$leaf['options']['gp-thumb-sizing-type'],$leaf['options']['gp-quality'],$leaf['options']['gp-panelbgcolour'],false);

	$return_html .= '	<li class="gp-nav-thumbs grid-thumbnails"  style="display:inline-block;position:relative;top:0;float:left;width:'.($leaf['options']['gp-thumb-width']).'px;'.$gp_thumb_padding.'">';
		switch($leaf['options']['gp-link-to']) {

			case 'lightbox':
	$return_html .= '		<a href="'.$gp_data['image_url'].'" rel="prettyPhoto-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.str_replace('"','&#8221;',$gp_data['caption']).'">';
	$return_html .= '			<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3>';
						}
	$return_html .= '						</a>';
				break;

			case 'url':
	$return_html .= '		<a href="'.$gp_data['link_url'].'" rel="image-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
	$return_html .= '			<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3>';
						}
	$return_html .= '						</a>';
				break;

			case 'zoomup':
				$image_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-image-width'], $leaf['options']['gp-image-height'], 'center','center',$gp_source_id.'img'.$thumb_id, $leaf['id'],'auto',$leaf['options']['gp-quality'],"#fff",true);

	$return_html .= '			<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'" rel="#zoomup-'.$leaf['id'].'-'.$thumb_id.'" class="zoomup"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3>';

						}

	$return_html .= '		<div id="zoomup-'.$leaf['id'].'-'.$thumb_id.'" class="clean_overlay" style="width:'.$leaf['options']['gp-image-width'].'">';	
	$return_html .= '			<img src="'.$image_src['new_image_url'].'"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3><span class="zoomup-caption">'.$gp_data['caption'].'</span>';
	
						}
	$return_html .= '		</div>';
	
				break;


			case 'cloudzoomoutside':
//					$image_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-image-width'], $leaf['options']['gp-image-height'], 'center','center',$gp_source_id.'img'.$thumb_id, $leaf['id'],'auto',$leaf['options']['gp-quality'],"#ffffff",true);

	$return_html .= '		<a href="'.$gp_data['image_url'].'" class="cloud-zoom" rel="position: \'outside\', adjustX: '.($gp_thumb_padding_val).', adjustY:-'.($leaf['options']['gp-thumb-height']).', zoomWidth:'.$leaf['options']['gp-image-width'].', zoomHeight:'.$leaf['options']['gp-image-height'].', tint:\'#ffffff\', tintOpacity:0.3, lensOpacity:0" title="'.$gp_data['caption'].'">';
	$return_html .= '			<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3>';
						}
	$return_html .= '						</a>';
	
				break;

			case 'cloudzoominside':
	$return_html .= '		<a href="'.$gp_data['image_url'].'" class="cloud-zoom" rel="position: \'inside\'" title="'.$gp_data['caption'].'">';
	$return_html .= '			<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/>';
	$return_html .= '						</a>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3>';
						}
				break;


			case 'none':
	$return_html .= '		<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/>';
						if ($leaf['options']['gp-textlocation'] != 'none') {
	$return_html .= '			<br/><h3>'.$gp_data['title'].'</h3>';
						}
				break;
		}				
	$return_html .= '	</li>';
									}
	$return_html .=	'</ul>';
	$return_html .= '</div>';	
	

	return $return_html;
}

function gp_scripts_gallery_grid($leaf){
	$return_js = "";
// For a link like <a href="one.jpg"><img src="oneThumbNail.jpg" /></a>

	$return_js .= "
		jQuery(window).load(function (){

			jQuery('.grid-thumb img[rel]').overlay({closeOnClick:true});

		});";

	// Other JS	
	if ($leaf['options']['gp-link-to'] == 'lightbox') {	
		// prettyPhoto js
		$gp_lb_auto =  ($leaf['options']['gp-lb-auto'] != false) ? 'true' : 'false';
	//	$gp_lb_circular = ($leaf['options']['gp-lb-circular'] != false) ? 'true' : 'false';
		$gp_lb_showfor = ($leaf['options']['gp-lb-showfor']*1000);
		$gp_lb_style = (!$leaf['options']['gp-lb-style']) ? 'pp_default' : $leaf['options']['gp-lb-style'];
	
		$social_code = '<div class="pp_social"><div class="twitter"><a href="http://twitter.com/share" class="twitter-share-button" data-count="none">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div><div class="facebook"><iframe src="http://www.facebook.com/plugins/like.php?locale=en_US&href=\'+location.href+\'&amp;layout=button_count&amp;show_faces=true&amp;width=500&amp;action=like&amp;font&amp;colorscheme=light&amp;height=23" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:500px; height:23px;" allowTransparency="true"></iframe></div></div>';
		$gp_lb_social = ($leaf['options']['gp-lb-social'] != false) ? $social_code : false;
		$gp_lb_style = $leaf['options']['gp-lb-style'];
		$gp_lb_deeplink = ($leaf['options']['gp-lb-social'] != false) ? 'true' : 'false';
		$gp_lb_opacity = $leaf['options']['gp-lb-bg-opacity'];
		$gp_lb_bgcolour = $leaf['options']['gp-lb-background'];
		
	
		$return_js .= " 
				jQuery(document).ready(
					function (){
							jQuery(\"a[rel^='prettyPhoto-".$leaf['id']."']\").prettyPhoto(
								{
									social_tools:'".$gp_lb_social."',
									opacity: '".$gp_lb_opacity."',
									animation_speed: 'normal',
									autoplay_slideshow: ".$gp_lb_auto.",
									deeplinking: ".$gp_lb_deeplink.",
									slideshow:".$gp_lb_showfor.",
									theme:'".$gp_lb_style."',
									backgcolor: '".$gp_lb_bgcolour."'
									
								}
							);
						}
					);
			";
	}	

	return $return_js;
}

/* 	==============================================================================================================================
	 GRID OPTIONS
	============================================================================================================================== */

function gp_options_grid_thumbs($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-thumb-height'] = '60';
		$leaf['options']['gp-thumb-width'] = '90';
		$leaf['options']['gp-pad-between-thumbs'] = true;
		$leaf['options']['gp-scroll-thumbs-hz'] = false;
		$leaf['options']['gp-grid-height'] = '';
		$leaf['options']['gp-grid-width'] = '';

		$leaf['options']['gp-thumb-sizing-type'] = 'crop';		
		$leaf['options']['gp-thumb-vertical-crop-align'] = 'center';
		$leaf['options']['gp-thumb-horizontal-crop-align'] = 'center';
		$leaf['options']['gp-thumb-image-fill'] = '#fff';
	}
	/// ------------------------------------------------
	// GRID THUMBS tab          -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('gridthumbs', $leaf['id']);
		// Thumb Width
		$title = 'Thumb Width';
		$tooltip = 'Sets the width of the thumbnails in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-width', 'value' => $leaf['options']['gp-thumb-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Thumb height
		$title = 'Thumb Height';
		$tooltip = 'Sets the height of the thumbnails in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-height', 'value' => $leaf['options']['gp-thumb-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


		// Crop type
		$sizing_type = array(
				'crop' => 'Crop width and height to fit',
				'exact' => 'Stretch to width and height (Warning: Can distort image)',
				'portrait' => 'Crop width, match height',
				'landscape' => 'Match width, crop height',
				'auto' => 'Fit within width and height'
			);
		$title = 'Thumb resizing method';
		$tooltip = 'Choose how you want the image resized in respect of its width and height to the Thumb Image Height and Width';
		$default = 'Default: Crop';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-thumb-sizing-type', 'value' => $leaf['options']['gp-thumb-sizing-type'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $sizing_type), $leaf['id']);
	

		/* Vertical crop alignment */
		$vertical_crop_align = array(
				'center' => 'Center',
				'top' => 'Top',
				'topquarter' => 'Top quarter',
				'bottomquarter' => 'Bottom quarter',
				'bottom' => 'Bottom'
			);
		$title = 'Vertical Crop Alignment';
		$tooltip = 'Choose how you want to vertically align the image in the thumb when it crops.';
		$default = 'Default: Center';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-thumb-vertical-crop-align', 'value' => $leaf['options']['gp-thumb-vertical-crop-align'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $vertical_crop_align), $leaf['id']);

		/* Horizontal crop alignment */
		$horizontal_crop_align = array(
				'center' => 'Center',
				'left' => 'Left',
				'leftquarter' => 'Left quarter',
				'rightquarter' => 'Right quarter',
				'right' => 'Right'
			);
		$title = 'Horizontal Crop Alignment';
		$tooltip = 'Choose how you want to horizontally align the image in the thumb when it crops';
		$default = 'Default: Center';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-thumb-horizontal-crop-align', 'value' => $leaf['options']['gp-thumb-horizontal-crop-align'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $horizontal_crop_align), $leaf['id']);

		/* Image fill colour */
/*
		$title = 'Thumb fill colour';
		$tooltip = 'Choose a fill colour for when an thumb doesn\'t fully fill the the dimensions of thethumb height and width';
		$default = 'Default:#fff';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-image-fill', 'value' => $leaf['options']['gp-thumb-image-fill'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
*/


		// Add padding betweem thumbs
		$title = 'Add padding between thumbnails';
		$tooltip = 'This will create space between your thumbnails equivalent to the padding you\'ve selected for your frame';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-pad-between-thumbs', 'value' => $leaf['options']['gp-pad-between-thumbs'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		/* Image Width */
		$title = 'Grid Width';
		$tooltip = 'Set the width in pixels you want to display the grid. Thumbs will wrap around. If you enter no value, the grid width wil be set to the leaf width.';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-grid-width', 'value' => $leaf['options']['gp-grid-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		
		/* Image height */
		$title = 'Grid Height';
		$tooltip = 'Set the height in pixels you want to display the grid. Thumbs will scroll if the fill more than the height.  If you enter no value, the grid height wil be set to the leaf height.';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-grid-height', 'value' => $leaf['options']['gp-grid-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Scroll horizontally in grid view
		$title = 'Scroll thumbs horizontal in grid';
		$tooltip = 'This setting will scroll the thumbnails horizontally in the gird mode, instead of wrapping them.';
		$default = 'Default: Off';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-scroll-thumbs-hz', 'value' => $leaf['options']['gp-scroll-thumbs-hz'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

	HeadwayLeafsHelper::close_tab();

}

function gp_options_images_grid($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-album'] = 'Samples: 98989898';
		$leaf['options']['gp-order-az'] = 'ASC';
		$leaf['options']['gp-order-by'] = 'title';
		$leaf['options']['gp-link-to'] = 'lightbox';
		$leaf['options']['gp-recreate-images']	= false;

		$leaf['options']['gp-image-width'] = '600';
		$leaf['options']['gp-image-height'] = '400';
		$leaf['options']['gp-quality'] = '70';

		$leaf['options']['gp-image-borders'] = false;
		$leaf['options']['gp-image-padding'] = 0;
	}

	/// ------------------------------------------------
	// Images grid tab					   -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('images', $leaf['id']);

		/* Album */
		/* Create a list of all galleries in G+, HW and NG prefixed with their source name */
		$gp_albums = GPFunctions::get_galleries(); // Located in gp_functions.php
		$gp_album_list = array();
		$gp_album_list[0] = 'No gallery selected';
		foreach ($gp_albums as $albums) {
			$gp_album_list[$albums['source'].$albums['post_id']] = $albums['source'].$albums['title'];
		}
		$title = 'Gallery';
		$tooltip = 'Select a gallery of images to display';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-album', 'value' => $leaf['options']['gp-album'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_album_list), $leaf['id']);

		// Order by
		$gp_order_by = array(
				'title' => 'Title',
				'ID' => 'Order added',
				'rand' => 'Random'
			);
		$title = 'Order By';
		$tooltip = 'Set what info you\'d like to order the images by. Note: Some galleries plugins may not support this.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-order-by', 'value' => $leaf['options']['gp-order-by'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_order_by), $leaf['id']);

		// Order
		$gp_order_az = array(
				'ASC' => 'Ascending',
				'DESC' => 'Descending'
			);
		$title = 'Order';
		$tooltip = 'Sets the order of the images, either ascending or descending. Note: Some galleries plugins may not support this.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-order-az', 'value' => $leaf['options']['gp-order-az'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_order_az, 'no-border'=>true), $leaf['id']);

		/* Image Width */
		$title = 'Display Image Width';
		$tooltip = 'Set the width in pixels you want to display the main images. <p class="hilite">Note:This is only used when the Link is set to Zoom Outside</p>';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-image-width', 'value' => $leaf['options']['gp-image-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);
		
		/* Image height */
		$title = 'Display Image Height';
		$tooltip = 'Set the height in pixels you want to display the main images. <p class="hilite">Note:This is only used when the Link is set to Zoom Outside</p>';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-image-height', 'value' => $leaf['options']['gp-image-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Compression
		$title = 'Image quality';
		$tooltip = 'Lower values will reduce the size of the file but also the clarity of the image. Higher values will make images slower loading.<br/>Value range is 0 to 100.';
		$default = 'Default: 70';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-quality', 'value' => $leaf['options']['gp-quality'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);



		// Link to
		$gp_link_to = array(
				'lightbox' => 'Lightbox',
				'url' => 'URL',
				'zoomup' => 'Zoom Up',
				'cloudzoominside' => 'Zoom Inside',
				'none' => 'Do nothing'
			);
		$title = 'Link to on image click/hover';
		$tooltip = 'Action on image click. <br/><strong>If you choose URL, you will need to enter the required URL in the descriptiuon field of the images in the selected G+ gallery.</strong>';
		$default = 'Default: Lightbox';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-link-to', 'value' => $leaf['options']['gp-link-to'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_link_to, 'no-border'=>true), $leaf['id']);


		// Recreate all images on publish or refresh
		$title = 'Do not recreate images for this leaf';
		$tooltip = 'By default, this leaf\'s images will be recreated when publishing or refreshing in the Visual Editor. <br/>Once you are happy with the images for this leaf, then check this so they don\'t get rereated each time. <br/> This has no effect other than saving the time it takes to reload the Visual Editor.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-recreate-images', 'value' => $leaf['options']['gp-recreate-images'], 'left-label' =>   gp_option_label($title, $tooltip, $default, 'right') , 'checkbox-label' => ''), $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<span class="hilite">If your images are causing an out of memory error, pleease reduce their size, or increase your system\'s PHP memory limit.<br/>On websites, there is generally no need to hve images any larger than 1000x1000px.</span>
		</td>
	</tr>
	';


		if (!function_exists( 'exif_imagetype' )) {	
			echo '<p class="gp-warning"><strong>Note:</strong> Your host\'s server does not have the PHP function exif_imagetype() enabled that is used for image validation. G+ has to use the much slower getimagesize() instead. This might cause the leaf to run noticeably slower.</p>';
		}
	HeadwayLeafsHelper::close_tab();

}