<?php

function gp_leaf_options_slider($leaf){
	/* Set default values */

	$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	$tabs = array();
		
		$tabs = array(
			'images' => 'Images',
			'frame' =>	'Frame',
			'navbuttons' => 'Nav Buttons',
			'navthumbs' => 'Nav Thumbs',
			'text' => 'Text',
			'slideshow' => 'Slideshow',
			'lightbox' => 'Lightbox',
			'css3' => 'CSS3 Styling',
			'miscellaneous' => 'Miscellaneous'
		);
		HeadwayLeafsHelper::create_tabs($tabs, $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<a href="'.GP_COLOUR_PICKER.'" target=_blank>Online Color Code Generator Tool</a><br />
		</td>
	</tr>';
	
	$leaf['type'] = 'gallery-plus';

	gp_options_images($leaf);	
	gp_options_frame($leaf);	
	gp_options_nav_buttons_slider($leaf);	
	gp_options_nav_thumbs_slider($leaf);	
	gp_options_text($leaf);	
	gp_options_slideshow_slider($leaf);	
	gp_options_lightbox($leaf);	
	gp_options_css3($leaf);	
	gp_options_misc($leaf);	

}

/*

Functions:
	gp_initialize_gallery_plugins($leaf)
	gp_build_gallery($leaf)
	gp_scripts_gallery($leaf)

This file calls the code for the galleries.

As new gallery styles are added, this folder will be updated.

*/


// do all enqueue stuff, js, css for each gallery plugged in


function gp_build_sk_gallery($leaf) {
	$return_html = '';
	// this will be switch:cased
	$gp_selected_gallery = $leaf['options']['gp-album'];
	$gp_using_source = substr($leaf['options']['gp-album'],0,7);
	if ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] && $leaf['options']['gp-auto']) {
		$leaf['options']['gp-shownavitems'] = 0;	
	}

	$gp_images = false;
	$gp_gallery_fail = 'insufficient_images';

	$nav_btn_style = gp_fix_old_sk_buttons($leaf);
	$nav_button_css = ';background-image:url('.GP_MEDIA_URL.'/nav-buttons/'.$nav_btn_style.')';

	$gp_process = GPFunctions::process_gallery($leaf,$gp_using_source);
	$gp_selected_gallery = $gp_process[0]; 
	$gp_images = $gp_process[1];
	$gp_source_id = $gp_process[2];
	$gp_gallery_fail = $gp_process[3];
	
	$gp_no_caption = (!$gp_data['caption'])  ? ' no-caption ' : '';	
	$gp_gallery_source = $gp_source_id.$gp_selected_gallery;

/*
	if (!$gp_images) {
		return $gp_gallery_fail;
	}
*/


	if (!$gp_images) {return '<div id="sliderkit-gallery-'.$leaf['id'].'">No image in selected gallery. Please add some or select another gallery</div>';}
	

	$image_width = $leaf['options']['gp-image-width'];
	$image_height = $leaf['options']['gp-image-height'];

	
	$gp_type = '';
	$gp_navpos = '';
	$gp_movepanel = '';
	$gp_movetext = '';
	$gp_height ='';
	$gp_nav_width_css = '';
	$gp_nav_width = 95;
	$gp_prev_loc ='';
	$gp_next_loc = '';
	$gp_rev = (!$leaf['options']['gp-invert-buttons']) ? '' : ' rev';
	$thumb_id= 0;
	$image_id = 0;
	$gp_thumb_padding_val = (!$leaf['options']['gp-pad-between-thumbs']) ? 0 : ($leaf['options']['gp-panel-padding']/2);
	


	//Build lightbox settings
	
	

	switch ($leaf['options']['gp-nav-pos']) {
	
// Horizontal
	case 'top':
		$gp_type = 'horizontal';
		$gp_navpos = 'top:0;';
		$gp_nav_height = ($leaf['options']['gp-thumb-height']+$leaf['options']['gp-panel-padding']);
		$gp_nav_height_css = 'height:'.$leaf['options']['gp-thumb-height'].'px;';
		$gp_nav_width_css = 'width:'.($leaf['options']['gp-shownavitems']*($leaf['options']['gp-thumb-width'])).'px;';
		$gp_height ='height:'.($image_height).'px;';
		$gp_movepanel = 'top:'.($gp_nav_height).'px;';
		$gp_prev_loc = ($leaf['options']['gp-panelbtnshover']) ?  'height:'.($image_height).'px; top:'.($gp_nav_height).'px;' : '';
		$gp_next_loc = ($leaf['options']['gp-panelbtnshover']) ?  'height:'.($image_height).'px; top:'.($gp_nav_height).'px;' : '';
		$gp_nav_pad_bottom = $gp_nav_height;
		$gp_thumb_padding = 'padding: 0 '.$gp_thumb_padding_val.'px;';
		$gp_nav_btn_pad = 'margin-top:'.(($leaf['options']['gp-thumb-height']-32)/2).'px';
		break;


	case 'bottom':
		$gp_type = 'horizontal';
		$gp_navpos = 'bottom:0;';
		$gp_nav_height = ($leaf['options']['gp-thumb-height']+$leaf['options']['gp-panel-padding']);
		$gp_nav_height_css = 'height:'.$leaf['options']['gp-thumb-height'].'px;';
		$gp_nav_width_css = 'width:'.($leaf['options']['gp-shownavitems']*($leaf['options']['gp-thumb-width'])).'px;';
		$gp_height ='height:'.($image_height).'px;';
		$gp_movepanel = 'top:0px;';
		$gp_prev_loc = ($leaf['options']['gp-panelbtnshover']) ?  'height:'.($image_height).'px;' : '';
		$gp_next_loc = ($leaf['options']['gp-panelbtnshover']) ?  'height:'.($image_height).'px;' : '';
		$gp_nav_pad_bottom = $gp_nav_height;
		$gp_thumb_padding = 'padding: 0 '.$gp_thumb_padding_val.'px;';
		$gp_nav_btn_pad = 'margin-top:'.(($leaf['options']['gp-thumb-height']-32)/2).'px';
		break;

	case 'none';
		$gp_type = 'horizontal';
		$gp_navpos = 'display:none;';
		$gp_movetext = '';
		$gp_movepanel = '';
		$gp_height ='height:'.($image_height).'px;';
		$gp_nav_pad_bottom = 0;
		break;

// Vertical
	case 'left':
		$gp_type = 'vertical';
		$gp_navpos = 'left:0;';
		$gp_movetext = '';
		$gp_nav_width = ($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding']);
		$gp_nav_width_css = 'width:'.$leaf['options']['gp-thumb-width'].'px';
		$gp_movepanel = 'left:'.($gp_nav_width).'px;';
		$gp_prev_loc = ($leaf['options']['gp-panelbtnshover']) ?  'left:'.($gp_nav_width).'px' : '';
		$gp_next_loc = '';
		$gp_thumb_padding = 'padding: '.$gp_thumb_padding_val.'px 0;';
		break;


	case 'right':
		$gp_type = 'vertical';
		$gp_navpos = 'right:0;';
		$gp_movetext = 'padding-left:20px;';
		$gp_nav_width = ($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding']);
		$gp_nav_width_css = 'width:'.$leaf['options']['gp-thumb-width'].'px';
		$gp_movepanel = 'left:0px;';
		$gp_prev_loc = '';
		$gp_next_loc = ($leaf['options']['gp-panelbtnshover']) ?  'right:'.$gp_nav_width.'px' : '';
		$gp_thumb_padding = 'padding: '.$gp_thumb_padding_val.'px 0;';
		break;

	}

	$image_shadow = ($leaf['options']['gp-image-shadows']) ? 'image-shadows' : '';
	$gp_text_location = $leaf['options']['gp-textlocation'];
	switch ($leaf['options']['gp-textlocation']) {
	 	case 'above':
			$gp_height ='height:'.($image_height).'px;padding-top:75px;';
			$gp_text_location = 'top';
			break;

	 	case 'below':
			$gp_height ='height:'.($image_height+75).'px;';
			$gp_text_location = 'bottom';
			break;
	}
	
	


	//-----------------------------------------
	// SliderKit
	// http://www.kyrielles.net/sliderkit/
	//-----------------------------------------

	switch ($gp_type) {

	// ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	// Horizontal
	// ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	case 'horizontal': 
		$return_html .= '<!-- Start photosgallery-horizontal -->';
		$return_html .= '<div id="sliderkit-gallery-'.$leaf['id'].'" class="sliderkit photosgallery-horizontal" style="'.$gp_height.'width:'.$image_width.'px;padding-bottom:'.($gp_nav_pad_bottom).'px;">';
							// Navigation bar
		$return_html .= '	<div class="sliderkit-nav" style="width:'.($image_width).'px; '.$gp_navpos.';'.$gp_nav_height_css.'">';
								// Nav thumbs
								if ($leaf['options']['gp-shownavitems'] > 1) {
		$return_html .= '			<div class="sliderkit-nav-clip" >';
		$return_html .= '       	    <ul class="gp-nav-container" style="'.$gp_nav_width_css.'">';
										foreach ($gp_images as $gp_data){
											$thumb_id++;
											$thumb_src = GPFunctions::generate_image($leaf,$gp_data['thumb_url'], $leaf['options']['gp-thumb-width'], $leaf['options']['gp-thumb-height'], 'center','center',$gp_source_id.'thm'.$thumb_id, $leaf['id'],'crop',$leaf['options']['gp-quality'],$leaf['options']['gp-panelbgcolour'],false);
		$return_html .= '					<li class="gp-nav-thumbs"  style="height:'.($leaf['options']['gp-thumb-height']).'px;width:'.($leaf['options']['gp-thumb-width']).'px;'.$gp_thumb_padding.'">';
		$return_html .= '						<a href="#" rel="nofollow" title="'.$gp_data['title'].'">';
		$return_html .= '						<img src="'.$thumb_src['new_image_url'].'"  title="'.$gp_data['title'].'"/></a>';
		$return_html .= '					</li>';
										}
		$return_html .= '				</ul>';
		$return_html .= '			</div>';
								}

								if ($leaf['options']['gp-showbackfwdnav']=='on') {
								// Nav back/fwd
		$return_html .= '		<div class="sliderkit-btn sliderkit-nav-btn sliderkit-nav-prev '.$gp_rev.' gp-nav-'.$nav_btn_style.'" style="'.$gp_nav_height_css.$gp_nav_btn_pad.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Back '.$leaf['options']['gp-scroll'].'" style="'.$nav_button_css.'">';
		$return_html .= '				<span>Back '.$leaf['options']['gp-scroll'].'</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
		$return_html .= '		<div class="sliderkit-btn sliderkit-nav-btn sliderkit-nav-next '.$gp_rev.' gp-nav-'.$nav_btn_style.'" style="'.$gp_nav_height_css.$gp_nav_btn_pad.'" >';
		$return_html .= '			<a rel="nofollow" href="#" title="Forward '.$leaf['options']['gp-scroll'].'" style="'.$nav_button_css.'">';
		$return_html .= '				<span>Forward '.$leaf['options']['gp-scroll'].'</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
								}
								// Nav next/prev buttons no hover
								if (!$leaf['options']['gp-panelbtnshover']) {
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-prev no-hover '.$gp_rev.' gp-nav-'.$nav_btn_style.'" style="'.$gp_nav_height_css.$gp_nav_btn_pad.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Previous photo"  style="'.$nav_button_css.'">';
		$return_html .= '				<span>Previous photo</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-next  no-hover '.$gp_rev.' gp-nav-'.$nav_btn_style.'" style="'.$gp_nav_height_css.$gp_nav_btn_pad.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Next photo" style="'.$nav_button_css.'">';
		$return_html .= '				<span>Next photo</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
								}
		$return_html .= '	</div> <!-- end sliderkit navigation -->';
		$return_html .= '	<div class="sliderkit-panels">';
								// Panel hover nav prev/next buttons
								if ($leaf['options']['gp-panelbtnshover']) {
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-prev panel-hover" style="'.$gp_prev_loc.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Previous">';
		$return_html .= '				<span>Previous</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-next panel-hover" style="'.$gp_next_loc.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Next">';
		$return_html .= '				<span>Next</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
								}
								// Main images
								foreach ($gp_images as $gp_data){
									$gp_no_caption = (!$gp_data['caption'] && $leaf['options']['gp-textlocation']!='above' && $leaf['options']['gp-textlocation']!='below')  ? ' no-caption ' : 'has-caption';	
									$image_id++;
									$image_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $image_width, $image_height, $leaf['options']['gp-vertical-crop-align'],$leaf['options']['gp-horizontal-crop-align'],$gp_source_id.'img'.$image_id, $leaf['id'],$leaf['options']['gp-sizing-type'],$leaf['options']['gp-quality'],$leaf['options']['gp-image-fill'],true);
		$return_html .= '			<div class="sliderkit-panel" style="'.$gp_movepanel.$gp_height.';background-color:'.$leaf['options']['gp-panelbgcolour'].';">';

			switch($leaf['options']['gp-link-to']) {
				case 'lightbox':
		$return_html .= '						<a href="'.$image_src['image_url'].'" rel="prettyPhoto-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.str_replace('"','&#8221;',$gp_data['caption']).'">';
					break;
				case 'url':
		$return_html .= '		<a href="'.$gp_data['link_url'].'" rel="image-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
					break;
				case 'none':
		$return_html .= '';
					break;
			}				

		$return_html .= '					<img src="'.$image_src['new_image_url'].'" alt="'.$gp_data['title'].'" />';
				if ($leaf['options']['gp-link-to'] !='none') {
		$return_html .= '						</a>';
				}
										// Text box
										if ($leaf['options']['gp-textlocation'] != 'none') {
		$return_html .= '				<div class="sliderkit-panel-textbox '.$gp_no_caption.'" style="'.$gp_text_location.':0;">';
		$return_html .= '					<div class="sliderkit-panel-text" style="color:'.$leaf['options']['gp-textcolour'].';">';
		$return_html .= '						<h4 style="color:'.$leaf['options']['gp-textcolour'].'">'.$gp_data['title'].'</h4>';
												if ($gp_data['caption']) {
		$return_html .= '							<p style="color:'.$leaf['options']['gp-textcolour'].'">'.$gp_data['caption'].'</p>';
												}
		$return_html .= '					</div> <!-- end sliderkit-panel-text -->';
		$return_html .= '					<div class="sliderkit-panel-overlay '.$gp_no_caption.'" style="width:'.($image_width-10).'px;background-color:'.$leaf['options']['gp-textbgcolour'].';opacity:'.$leaf['options']['gp-textbgopacity'].';filter:alpha(opacity='.($leaf['options']['gp-textbgopacity']*100).')">';
		$return_html .= '					</div> <!-- end sliderkit-panel-overlay -->';
		$return_html .= '				</div> <!-- end sliderkit-panel-textbox -->';
										}
		$return_html .= '			</div> <!-- end sliderkit-panel leaf-'.$leaf['id'].' - '.$gp_data['title'].'-->';
								}
		$return_html .= '	</div><!-- end sliderkit panels leaf-'.$leaf['id'].' -->';
		$return_html .= '</div><!-- // end of photosgallery-horizontal leaf-'.$leaf['id'].' -->';
		break;
		
	// ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	// Vertical
	// ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	case 'vertical':
		$return_html .= '<!-- Start photosgallery-vertical '.$leaf['id'].' -->';
		$return_html .= '<div id="sliderkit-gallery-'.$leaf['id'].'" class="sliderkit photosgallery-vertical" style="height:'.$image_height.'px;width:'.$image_width.'">';
							// Navigation bar
		$return_html .= '	<div class="sliderkit-nav"  style="height:'.($image_height).'px;'.$gp_navpos.';width:'.($leaf['options']['gp-thumb-width']).'px;">';
								// Nav thumbs
								if ($leaf['options']['gp-shownavitems'] > 1) {
		$return_html .= '			<div class="sliderkit-nav-clip" style="text-align:center;">';
		$return_html .= '				<ul class="gp-nav-container">';
											foreach ($gp_images as $gp_data){
												$thumb_id++;
												$thumb_src = GPFunctions::generate_image($leaf,$gp_data['thumb_url'], $leaf['options']['gp-thumb-width'], $leaf['options']['gp-thumb-height'], 'center','center',$gp_source_id.'thm'.$thumb_id, $leaf['id'],'crop',$leaf['options']['gp-quality'],$leaf['options']['gp-panelbgcolour'],false);
		$return_html .= '					<li class="gp-nav-thumbs" style="height:'.($leaf['options']['gp-thumb-height']).'px;width:'.$leaf['options']['gp-thumb-width'].'px;'.$gp_thumb_padding.'">';
		$return_html .= '						<a href="#" rel="nofollow" title="'.$gp_data['title'].'">';
		$return_html .= '							<img src="'.$thumb_src['new_image_url'].'"  title="'.$gp_data['title'].'"  class="'.$image_shadow.'"/>';
		$return_html .= '						</a>';
		$return_html .= '					</li>';
											}
		$return_html .= '				</ul>';
		$return_html .= '			</div>';
								}
								if ($leaf['options']['gp-showbackfwdnav']=='on') {
								// Nav back/fwd buttons
		$return_html .= '		<div class="sliderkit-btn sliderkit-nav-btn sliderkit-nav-prev  '.$gp_rev.' gp-nav-'.$nav_btn_style.'" style="'.$gp_nav_width_css.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Back '.$leaf['options']['gp-scroll'].'" style="'.$nav_button_css.'">';
		$return_html .= '				<span>Back '.$leaf['options']['gp-scroll'].'</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
		$return_html .= '		<div class="sliderkit-btn sliderkit-nav-btn sliderkit-nav-next  '.$gp_rev.' gp-nav-'.$nav_btn_style.'" style="'.$gp_nav_width_css.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Forward '.$leaf['options']['gp-scroll'].'" style="'.$nav_button_css.'">';
		$return_html .= '				<span>Forward '.$leaf['options']['gp-scroll'].'</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
								}
								if (!$leaf['options']['gp-panelbtnshover']) {
								// Nav next/prev buttons no hover
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-prev  '.$gp_rev.' gp-nav-'.$nav_btn_style.' no-hover " style="'.$gp_nav_width_css.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Previous photo"  style="'.$nav_button_css.'">';
		$return_html .= '				<span>Previous photo</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-next  '.$gp_rev.' gp-nav-'.$nav_btn_style.' no-hover " style="'.$gp_nav_width_css.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Next photo" style="'.$nav_button_css.'">';
		$return_html .= '				<span>Next photo</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
								}
		$return_html .= '	</div><!-- end sliderkit navigation -->';

		$return_html .= '	<div class="sliderkit-panels">';
								// Hover next/prev buttons
								if ($leaf['options']['gp-panelbtnshover']) {
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-prev gp-nav-'.$nav_btn_style.' panel-hover" style="'.$gp_prev_loc.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Previous">';
		$return_html .= '				<span>Previous</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
		$return_html .= '		<div class="sliderkit-btn sliderkit-go-btn sliderkit-go-next gp-nav-'.$nav_btn_style.' panel-hover" style="'.$gp_next_loc.'">';
		$return_html .= '			<a rel="nofollow" href="#" title="Next">';
		$return_html .= '				<span>Next</span>';
		$return_html .= '			</a>';
		$return_html .= '		</div>';
								}
								foreach ($gp_images as $gp_data){
									$gp_no_caption = (!$gp_data['caption'] && $leaf['options']['gp-textlocation']!='above' && $leaf['options']['gp-textlocation']!='below')  ? ' no-caption ' : 'has-caption';	
									$image_id++;
									$image_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $image_width, $image_height, $leaf['options']['gp-vertical-crop-align'],$leaf['options']['gp-horizontal-crop-align'],$gp_source_id.'img'.$image_id, $leaf['id'],$leaf['options']['gp-sizing-type'],$leaf['options']['gp-quality'],$leaf['options']['gp-image-fill'],true);
								// Slider images
		$return_html .= '		<div class="sliderkit-panel" style="'.$gp_movepanel.$gp_height.';background-color:'.$leaf['options']['gp-panelbgcolour'].';">';
			switch($leaf['options']['gp-link-to']) {
				case 'lightbox':
		$return_html .= '						<a href="'.$image_src['image_url'].'" rel="prettyPhoto-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
					break;
				case 'url':
		$return_html .= '		<a href="'.$gp_data['link_url'].'" rel="image-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
					break;
				case 'zoominside':
		$return_html .= '		<a href="'.$gp_data['image_url'].'" rel="zoom-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
					break;

				case 'none':
		$return_html .= '';
					break;
			}				
		$return_html .= '			<img src="'.$image_src['new_image_url'].'" alt="'.$gp_data['title'].'" />';
									if ($leaf['options']['gp-link-to'] !='none') {
		$return_html .= '				</a>';
									}
									if ($leaf['options']['gp-textlocation'] != 'none') {
									// Text box for image
		$return_html .= '			<div class="sliderkit-panel-textbox '.$gp_no_caption.'" style="'.$gp_text_location.':0;">';
		$return_html .= '				<div class="sliderkit-panel-text" style="color:'.$leaf['options']['gp-textcolour'].';">';
		$return_html .= '					<h4>'.$gp_data['title'].'</h4>';
												if ($gp_data['caption']) {
		$return_html .= '							<p style="color:'.$leaf['options']['gp-textcolour'].'">'.$gp_data['caption'].'</p>';
												}
		$return_html .= '				</div> <!-- end sliderkit-panel-text -->';
		$return_html .= '				<div class="sliderkit-panel-overlay '.$gp_no_caption.'" style="width:'.($image_width-10).'px;background-color:'.$leaf['options']['gp-textbgcolour'].';opacity:'.$leaf['options']['gp-textbgopacity'].';filter:alpha(opacity='.($leaf['options']['gp-textbgopacity']*100).');">';
		$return_html .= '				</div> <!-- end sliderkit-panel-overlay -->';
		$return_html .= '			</div> <!-- end sliderkit-panel-textbox -->';
									}
		$return_html .= '		</div> <!-- end sliderkit-panel leaf-'.$leaf['id'].' - '.$gp_data['title'].'-->';
								}
		$return_html .= '	</div> <!-- end sliderkit-panels leaf-'.$leaf['id'].'-->';
		$return_html .= '</div> <!-- // end of photosgallery-vertical leaf-'.$leaf['id'].'-->';

		break;
	}
	return $return_html;
}



function gp_fix_old_sk_buttons($leaf) {
// Configure when using old nav icons
	$nav_btn_style = $leaf['options']['gp-nav-style'];
	switch ($nav_btn_style) {
		case 'squares-bwg':
			$nav_btn_style = 'btn0-black-square-00.png';
			break;
		case 'squares-wbg':
			$nav_btn_style = 'btn0-white-square-00.png';
			break;
		case 'squares-grey':
			$nav_btn_style = 'btn0-grey-square-00.png';
			break;
		case 'squares-darkgrey':
			$nav_btn_style = 'btn20-grey-square-20.png';
			break;
		case 'circles-bwg':
			$nav_btn_style = 'btn0-black-circle-00.png';
			break;
		case 'circles-wbg':
			$nav_btn_style = 'btn0-white-circle-00.png';
			break;
		case 'glossy':
			$nav_btn_style = 'btn0-grey-circle-00.png';
			break;
		case 'custom':
			$nav_btn_style = 'btn20-blue-circle-20.png';
			break;
	}
	return $nav_btn_style;
}

function gp_scripts_gallery_slider($leaf){
	
	// SliderKit variables
	$return_js = "";
	$gp_start   = ($leaf['options']['gp-start'] == 0) ? 0 : ($leaf['options']['gp-start']-1);
	$gp_auto   = ($leaf['options']['gp-auto'] != false) ? 'true' : 'false';
	$gp_autospeed  = $leaf['options']['gp-autospeed']*1000;
	$gp_mousewheel  = ($leaf['options']['gp-mousewheel'] != false) ? 'true' : 'false';
	$gp_keyboard  = ($leaf['options']['gp-keyboard'] != false) ? 'true' : 'false';
	$gp_panelclick  = ($leaf['options']['gp-panelclick'] != false) ? 'true' : 'false';
	$gp_circular  = ($leaf['options']['gp-circular'] != false) ? 'true' : 'false';
	$gp_shownavitems = ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] || !$leaf['options']['gp-shownavitems']) ? 0 : $leaf['options']['gp-shownavitems'];
	$gp_navitemshover = ($leaf['options']['gp-navitemshover'] != false) ? 'true' : 'false';
	$gp_navclipcenter = ($leaf['options']['gp-navclipcenter'] != false) ? 'true' : 'false';
	$gp_navfx   = $leaf['options']['gp-navfx'];
	$gp_scroll   = $leaf['options']['gp-scroll'];
	$gp_scrollspeed  = $leaf['options']['gp-scrollspeed']*1000;
	$gp_scrolleasing = $leaf['options']['gp-scrolleasing'];
	$gp_panelfx   = $leaf['options']['gp-panelfx'];
	$gp_panelfxspeed = $leaf['options']['gp-panelfxspeed']*1000;
	$gp_panelfxeasing = $leaf['options']['gp-panelfxeasing'];
	$gp_panelbtnshover = ($leaf['options']['gp-panelbtnshover'] != false) ? 'true' : 'false';
	$gp_verticalnav  = ($leaf['options']['gp-nav-pos'] == 'left' || $leaf['options']['gp-nav-pos'] == 'right') ? 'true' : 'false';
	$gp_verticalslide = ($leaf['options']['gp-verticalslide'] != false) ? 'true' : 'false';
	$gp_fastchange  = ($leaf['options']['gp-fastchange'] != false) ? 'true' : 'false';
	$gp_scrollatend  = ($leaf['options']['gp-circular'] != false) ? 'true' : 'false';


	// SliderKit js
	$return_js = "
			jQuery(document).ready(
				function (){
					jQuery('#sliderkit-gallery-".$leaf['id']."').sliderkit({
						start:".$gp_start.",
						auto: ".$gp_auto.",
						autospeed: ".$gp_autospeed.",
						panelclick: ".$gp_panelclick.",
						circular:".$gp_circular.",
						shownavitems: ".$gp_shownavitems.",
						navitemshover:".$gp_navitemshover.",
						navclipcenter:".$gp_navclipcenter.",
						panelfx: 'fading',
						panelfxspeed: ".$gp_panelfxspeed.",
						panelbtnshover: ".$gp_panelbtnshover.",
						verticalnav: ".$gp_verticalnav.",
						navscrollatend: ".$gp_scrollatend.",
						fastchange: ".$gp_fastchange."
					});
				}
			);
		";
	
	// Other js
	
	if ($leaf['options']['gp-link-to'] == 'lightbox') {	
		// prettyPhoto js
		$gp_lb_auto =  ($leaf['options']['gp-lb-auto'] != false) ? 'true' : 'false';
	//	$gp_lb_circular = ($leaf['options']['gp-lb-circular'] != false) ? 'true' : 'false';
		$gp_lb_showfor = ($leaf['options']['gp-lb-showfor']*1000);
		$gp_lb_style = (!$leaf['options']['gp-lb-style']) ? 'pp_default' : $leaf['options']['gp-lb-style'];
	
		$social_code = '<div class="pp_social"><div class="twitter"><a href="http://twitter.com/share" class="twitter-share-button" data-count="none">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div><div class="facebook"><iframe src="http://www.facebook.com/plugins/like.php?locale=en_US&href=\'+location.href+\'&amp;layout=button_count&amp;show_faces=true&amp;width=500&amp;action=like&amp;font&amp;colorscheme=light&amp;height=23" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:500px; height:23px;" allowTransparency="true"></iframe></div></div>';
		$gp_lb_social = ($leaf['options']['gp-lb-social'] != false) ? $social_code : false;
		$gp_lb_style = $leaf['options']['gp-lb-style'];
		$gp_lb_deeplink = ($leaf['options']['gp-lb-social'] != false) ? 'true' : 'false';
		$gp_lb_opacity = $leaf['options']['gp-lb-bg-opacity'];
		$gp_lb_bgcolour = $leaf['options']['gp-lb-background'];
		
	
		$return_js .= " 
				jQuery(document).ready(
					function (){
							jQuery(\"a[rel^='prettyPhoto-".$leaf['id']."']\").prettyPhoto(
								{
									social_tools:'".$gp_lb_social."',
									opacity: '".$gp_lb_opacity."',
									animation_speed: 'normal',
									autoplay_slideshow: ".$gp_lb_auto.",
									deeplinking: ".$gp_lb_deeplink.",
									slideshow:".$gp_lb_showfor.",
									theme:'".$gp_lb_style."',
									backgcolor: '".$gp_lb_bgcolour."'
									
								}
							);
						}
					);
			";
	}	


	return $return_js;
}
/* 	==============================================================================================================================
	 SLIDER OPTIONS
	============================================================================================================================== */

function gp_options_nav_thumbs_slider($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-shownavitems'] = 3;
		$leaf['options']['gp-scroll'] =3;
		$leaf['options']['gp-navitemshover'] = false;
		$leaf['options']['gp-thumb-height'] = '60';
		$leaf['options']['gp-thumb-width'] = '90';
		$leaf['options']['gp-pad-between-thumbs'] = true;
		$leaf['options']['gp-navclipcenter'] = true;
	}

	/// ------------------------------------------------
	// NAVIGATION THUMBS tab          -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('navthumbs', $leaf['id']);

		// Number thumbs to show
		$title = 'Show <em>n</em> thumbnails (0 to hide)';
		$tooltip = 'Number of thumbnails to show in the navigation bar. ';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-shownavitems', 'value' => $leaf['options']['gp-shownavitems'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// No thumbs to scroll in nav
		$title = 'Skip <em>n</em> images';
		$tooltip = 'Sets how many images to skip when the back/forward navigation buttons are clicked';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-scroll', 'value' => $leaf['options']['gp-scroll'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


		// Scroll on hover
		$title = 'Scroll images on hover over thumbs';
		$tooltip = 'When selected, the images will automatically scrool to the one you hover the mouse over.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-navitemshover', 'value' => $leaf['options']['gp-navitemshover'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Thumb Width
		$title = 'Thumb Width';
		$tooltip = 'Sets the width of the thumbnails in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-width', 'value' => $leaf['options']['gp-thumb-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Thumb height
		$title = 'Thumb Height';
		$tooltip = 'Sets the height of the thumbnails in pixels';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-height', 'value' => $leaf['options']['gp-thumb-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Add padding betweem thumbs
		$title = 'Add padding between thumbnails';
		$tooltip = 'This will create space between your thumbnails equivalent to the padding you\'ve selected for your frame';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-pad-between-thumbs', 'value' => $leaf['options']['gp-pad-between-thumbs'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Center nav
		$title = 'Centre thumbs in navigation';
		$tooltip = 'Turn this off if you want the thumbnails to fill the full width or height of the navigation bar.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-navclipcenter', 'value' => $leaf['options']['gp-navclipcenter'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);


	HeadwayLeafsHelper::close_tab();

}

function gp_options_nav_buttons_slider($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-nav-pos'] = 'bottom';
		$leaf['options']['gp-nav-style'] = 'btn211-metal-circle.png';
		$leaf['options']['gp-invert-buttons'] = false;
		$leaf['options']['gp-panelbtnshover'] = false;
		$leaf['options']['gp-showbackfwdnav'] = true;
	}
	/// ------------------------------------------------
	// NAVIGATION BUTTONS tab          -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('navbuttons', $leaf['id']);

		$gp_navpos = array(
				'top' => 'Top',
				'bottom' => 'Bottom',
				'left' => 'Left',
				'right' => 'Right',
				'none' => 'Do not show'
			);

		// Nav position
		$title = 'Navigation position';
		$tooltip = 'Position within the frame where you want to display the navigation bar, which includes buttons and thumbnails.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-nav-pos', 'value' => $leaf['options']['gp-nav-pos'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_navpos), $leaf['id']);


		$gp_nav_dir = scandir(GP_MEDIA_PATH.'/nav-buttons');
		if (!$gp_nav_dir) {
			$nav_btn_view = 'The nav button images folder is not accessible. Please check its permissions.';
			$gp_nav_buttons['none'] = 'No nav buttons found';
		} else {
			$inc = 0;
			$gp_nav_buttons = array();
			$gp_nav_buttons_img = array();
			
			$nav_btn_view = '';
			foreach ($gp_nav_dir as $nav_file) {
				if (substr($nav_file,0,3) == 'btn') {
					$search = array('/btn/','/\.\w*/','/-|_/');
					$replace = array('','',' ');
					$nav_btn_text = preg_replace($search,$replace,$nav_file);			
					$gp_nav_buttons[$nav_file] = ucwords($nav_btn_text);
					$nav_btn_view .= '<div class="gp-nav-btn-samples" style="background-image:url('.GP_MEDIA_URL.'/nav-buttons/'.$nav_file.')"><span style="background-color:'.$leaf['options']['gp-panelbgcolour'].'!important;"><img src="'.GP_MEDIA_URL.'/nav-buttons/'.$nav_file.'"/><br/><br/><strong>'.ucwords($nav_btn_text).'</strong></span></div>';
				}
			}
		}

		echo '<tr>';
		echo '		<th scope="row"><label for="'.$leaf['id'].'_categories">Navigation button samples</label></th>';
		echo '		<td>';
		echo 			$nav_btn_view;
		echo '		</td>';
		echo '	</tr>';

		// Nav style
		$title = 'Navigation style<br/>See samples above';
		$tooltip = 'Choose the style of navigation buttons you want to use in the navigation bar.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-nav-style', 'value' => $leaf['options']['gp-nav-style'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_nav_buttons), $leaf['id']);

		// Invert buttons
		$title = 'Invert button colours';
		$tooltip = 'When selected, the buttons will be swapped to use what would notmally be their hover appearance.This doubles the button options available';
		$default = 'Default: No';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-invert-buttons', 'value' => $leaf['options']['gp-invert-buttons'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Panel nav hover
		$title = 'Show next/previous image buttons on hover over images, not in nav bar';
		$tooltip = 'Turn this off if you\'d like to display the next/previous navigation buttons when you mouse over the image instead of in the navigation bar.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-panelbtnshover', 'value' => $leaf['options']['gp-panelbtnshover'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Show back forward
		$title = 'Show back/forward a page buttons';
		$tooltip = 'Back/forward buttons skip back or forward the number of iamges specified in the \'Skip n images\' setting above.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-showbackfwdnav', 'value' => $leaf['options']['gp-showbackfwdnav'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);



	HeadwayLeafsHelper::close_tab();

}

function gp_options_slideshow_slider($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-auto'] = false;
		$leaf['options']['gp-circular'] = true;
		$leaf['options']['gp-autospeed'] = 4;
		$leaf['options']['gp-panelfxspeed']= 2;
		$leaf['options']['gp-fastchange'] = true;

		$leaf['options']['gp-mousewheel'] = false;
		$leaf['options']['gp-keyboard'] = false;
		$leaf['options']['gp-panelclick'] = false;
		$leaf['options']['gp-scroll'] = 3;
		$leaf['options']['gp-scrollspeed'] = 1;
		$leaf['options']['gp-scrolleasing'] = 'swing';
		$leaf['options']['gp-panelfx'] = 'fading';
		$leaf['options']['gp-panelfxeasing']= 'swing';
		$leaf['options']['gp-verticalslide'] = false;
	}
	/// ------------------------------------------------
	// Slides SETTINGS tab             -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('slideshow', $leaf['id']);

		// Auto start
		$title = 'Auto start slideshow';
		$tooltip = 'Enable this if you wish to automatically start scrolling through the images after the pages loads.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-auto', 'value' => $leaf['options']['gp-auto'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Continous slideshow
		$title = 'Loop back to first';
		$tooltip = 'Enable this if you want to go back to the first image after the last one.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-circular', 'value' => $leaf['options']['gp-circular'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Show images for...
		$title = 'Show images for <em>n</em> seconds';
		$tooltip = 'Sets the time the images display for';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-autospeed', 'value' => $leaf['options']['gp-autospeed'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

 		// Tranisition speed
		$title = 'Transition speed';
		$tooltip = 'Sets the time it takes to change from one image to the next';
		$default = '';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-panelfxspeed', 'value' => $leaf['options']['gp-panelfxspeed'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Fast change
		$title = 'Fast change';
		$tooltip = 'When enabled, will change to next image straight away instead of waiting for current one to load when using navigation buttons.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-fastchange', 'value' => $leaf['options']['gp-fastchange'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);


		
	HeadwayLeafsHelper::close_tab();
}

